C     Last change:  JRC  18 Jan 97    3:38 pm
C-----------------------------------------------------------------------
C            INPUT-OUTPUT SUBROUTINES-1
C-----------------------------------------------------------------------
      SUBROUTINE READNEWS
C-----------------------------------------------------------------------
C----- *** ReadNew ***   Input of FullProf Parameters
C----- Authors :
C-----   Juan Rodriguez-Carvajal
C-----   Alain Filhol
C-----
C----- Remarks :
C-----   We use neither the "*" nor the "I,F,A" FORTRAN free formats
C-----   since the former may attempt to read on the next line
C-----   and the later is not standard and requires "," separators
C-----   on VAX computers.
C-----   Integer fields :
C-----      Valid separators are: space(s), a Tab, a sign
C-----      e.g.:  10 -20+30   40
C-----   Real fields :
C-----      Valid separators are: space(s), a Tab, a sign
C-----      F,E,D formats are accepted (case insensitive)
C-----      e.g.:  10 -2.10+3.0e-4   .40D5  6.01d-12
C-----   Character fields :
C-----      Valid separators are: space(s) or a Tab
C-----      must not be empty
C-----      must not contain spaces (which is a separator)
C-----      may be shorter but not longer that expected
C-----      e.g. 4A4 fields expected:
C-----           your input: "  abcd e fgh    ijk "
C-----           is read as: "abcd" "e   " "fgh " "ijk "
C-----------------------------------------------------------------------
      INCLUDE      'ful0.inc'
      INCLUDE      'ful1.inc'
      INCLUDE      'ful2.inc'
cfree
      Character    aLine*132,FMTformat*132,FMTfields*80
      Integer*4    nCarL,iErr,Line_Nb
      common/Line_count/Line_Nb
cfree
C
      COMMON      /FORMATO/
     +      INSTR,NUMOR,TSAMP
      COMMON      /SPG/
     +      NSPGRP,NSP(1),NCONT(10),FILL(1),ICE,MULTG
      COMMON      /BLNK1/
     +      NJNK(22),FILL2(751)
C
      COMMON      /CELLX/
     +      AA,B,C,ALPHA,BETA,GAMMA,AL(3,3),IMU
C
      DIMENSION BACK(6),FBACK(6)
      LOGICAL read_bac
      EQUIVALENCE (GLB(1),ZER),(GLB(2),BACK(1))
      EQUIVALENCE (GLB(8),DISP),(GLB(9),TRANSP)
      EQUIVALENCE (AGLB(1),FLGZER),(AGLB(2),FBACK(1))
      EQUIVALENCE (AGLB(8),FLDISP),(AGLB(9),FLTRNS)
C---------------
      Call mess(' => Reading control file *.PCR ...')
      READ(i_pcr,'(a)',END=99999)TITLE
      IF(TITLE(1:4).EQ.'FREE') THEN
        TITLE(1:70)=TITLE(5:70)
      elseif(TITLE(1:4).EQ.'COMM') THEN
        TITLE(1:70)=TITLE(5:70)
        icomm=1
      ENDIF
C---------------
C
      RMUT    = 0.0
      IRIT    = 1
      I_RAY   = 0
      Line_Nb = 1      ! Line 1 (title) already read
C
C
C------------------------------------------------------- FORMAT(BZ,14I4)
      FMTfields = 'iiiiiiiiiiiiiiiii'
      Line_Nb = Line_Nb +1
      Call FindFMT(i_Pcr,aLine,FMTfields,FMTformat,nCarL,iErr)
      if (iErr.eq.-1) GoTo 99999
      if (iErr.ne.0)  GoTo 99995
      READ(aLine,FMTformat)
     +      JOBTYP,NPROF,NPHASE,NBCKGD,NEXCRG,NSCAT,NORI,
     +      IDUM,IWGT,ILOR,IASG,IRESO,ISTEP,NRELL,ICRYG,IXUNIT,ICORR
C-----------------------------------------------------------------------
C
      NSC=IABS(NSCAT)
      if(ICRYG.ne.0) then
       NPROF=0
       NBCKGD=0
       Nexcrg=0
       idum=0
       ireso=0
       Istep=0
      endif
      if(NPROF.EQ.8) then
        Call Openfile(20,0,1)
        read(i_shp,'(a)')
        read(i_shp,*) NP8,nupr,(anpr(j),j=1,nupr)
        if(NP8.gt.npr) stop ' => Too many points in numerical profile!'
        do i=1,NP8
         read(i_shp,*) X_8(i),(P_8(i,j),PP_8(i,j),j=1,nupr)
        end do
      endif
      if(icorr.ne.0) then
        Call Openfile(21,0,1)
        read(i_cor,'(a)')
        npcorr=0
        do i=1,Nprc
         read(i_cor,*,end=11) corrp(i),corrv(i)
        npcorr=npcorr+1
        end do
  11  close(unit=i_cor)
      endif
      IF(IRESO.NE.0.AND.NPROF.NE.7) THEN
       CALL STOP_COND(' ===>>> Illegal use of resolution function!! ',0)
       CALL STOP_COND('        NPROF must be equal to 7!  ',1)
      End If
      IASYM=0
      IF(NPHASE.LT.0) THEN
      NPHASE=-NPHASE
      IASYM=1
      ENDIF
C
      IF(IRESO.NE.0) Then
 1      Line_Nb = Line_Nb +1
        READ(i_Pcr,'(A)',END=99999) FILEres
        if(fileres(1:1).eq.'!') goto 1
      End If

      IF(NBCKGD.LT.0) THEN
        NBCKGD=-NBCKGD
        ISBAC=-1
      Else
        ISBAC=1
      End If
       read_bac=(NBCKGD.eq.1.AND.ISBAC.EQ.1).or.
     +          (NBCKGD.eq.2.AND.ISBAC.EQ.-1)
C
      IF(IDUM.eq.3)   RMUT=1.0
      IF(NPHASE.EQ.0) NPHASE=1
      IF(NBCKGD.GT.IBACP) THEN
      Call message('         Number of backg. points:',NBCKGD,0.0,1)
      Call message(' Maximum Number of backg. points:',IBACP ,0.0,1)
       CALL STOP_COND(' Too many background points ',1)
      End If
C
      IF(NEXCRG.GT.IEXCL) THEN
      call message('          Number of excl. regions: ',NEXCRG,0.0,1)
      call message('  Maximum number of excl. regions: ',IEXCL,0.0,1)
       CALL STOP_COND(' Too many excluded regions ',1)
      End If
C
      NPROF=NPROF+1
      WRITE(i_Sum,'(a)')  ' => Title:'//TITLE
      WRITE(i_Out,'(/A/)') ' ==> CONDITIONS OF THIS RUN:'
      WRITE(i_Sum,'(/A/)') ' ==> CONDITIONS OF THIS RUN:'
C
      IF(JOBTYP.EQ.0) THEN
        I_RAY=1
      Fmtfields=' => Global Refinement of X-ray powder diffraction data'
      if(ICRYG.ne.0)
     +Fmtfields=' => Refinement of X-ray integrated intensity data'
        WRITE(i_Out,'(a)') Fmtfields
        WRITE(i_Sum,'(a)') Fmtfields
      End If
C
      IF(iabs(JOBTYP).EQ.1) THEN
      Fmtfields=' => Global Refinement of neutron powder data '
      if(ICRYG.ne.0)
     +Fmtfields=' => Refinement of Neutron integrated intensity data'
        WRITE(i_Out,'(a)') Fmtfields
        WRITE(i_Sum,'(a)') Fmtfields
       if(jobtyp.lt.0) then
        Fmtfields=' => Neutron Time-Of-Flight data'
        WRITE(i_Out,'(a)') Fmtfields
        WRITE(i_Sum,'(a)') Fmtfields
       End If
      End If
      if(ICRYG.eq.2) then
        WRITE(i_Out,'(a,i3,a)')
     +   ' => Montecarlo search for a number of ',nrell,' parameters'
        WRITE(i_Sum,'(a,i3,a)')
     +   ' => Montecarlo search for a number of ',nrell,' parameters'
      if(nrell.eq.0)
     + call stop_cond('Montecarlo search for 0 parameters???',1)
      endif
      if(icorr.ne.0) then
        WRITE(i_Out,'(a)')' => Intensities corrections in file *.cor'
        WRITE(i_Sum,'(a)')' => Intensities corrections in file *.cor'
      endif
C
      if(Icryg.eq.0) then   !If no global integrated intensity job
      IF(JOBTYP.EQ.2) THEN
      I_RAY=1
      WRITE(i_Out,'(a)')
     +      ' => Pattern calculation, X-ray'
      ENDIF
      if(I_ray.eq.1) then
        if(ilor.eq.0) then
      write(i_out,'(a)') '    Bragg-Brentano or Debye-Scherrer geometry'
      write(i_sum,'(a)') '    Bragg-Brentano or Debye-Scherrer geometry'
         elseif(ilor.eq.1) then
         write(i_out,'(a)') '    Flat plate with PSD'
         write(i_sum,'(a)') '    Flat plate with PSD'
         elseif(ilor.eq.2) then
         write(i_out,'(a)') '    Transmission Geometry'
         write(i_sum,'(a)') '    Transmission Geometry'
         elseif(ilor.eq.3) then
         write(i_out,'(a)') '    Synchrotron B-B/D-S geometry'
         write(i_sum,'(a)') '    Synchrotron B-B/D-S geometry'
        endif
      endif
      if(IXUNIT.eq.1) then
         write(i_out,'(a)') ' => Abcisa variable is T.O.F. in microsecs'
         write(i_sum,'(a)') ' => Abcisa variable is T.O.F. in microsecs'
      elseif(IXUNIT.eq.2) then
         write(i_out,'(a)') ' => Abcisa variable is Q in recipr. Angstr'
         write(i_sum,'(a)') ' => Abcisa variable is Q in recipr. Angstr'
      elseif(IXUNIT.eq.3) then
         write(i_out,'(a)') ' => Abcisa variable is S in recipr. Angstr'
         write(i_sum,'(a)') ' => Abcisa variable is S in recipr. Angstr'
      endif

      IF(iabs(JOBTYP).EQ.3) WRITE(i_Out,'(a)')
     +      ' => Pattern calculation, Neutrons'
      IF(iabs(JOBTYP).GT.3)
     + CALL STOP_COND(' Invalid JOBTYP ',1)
      WRITE(i_Out,'(a/)') ' => Title:'//TITLE
      WRITE(i_Out,'(a,i4/a,i4/a,i4)')
     +      ' => Number of phases: ',NPHASE,
     +  ' => Number of excluded regions: ',NEXCRG,
     +      ' => Number of scattering factors supplied: ',NSC
      IF (NORI.EQ.1) WRITE(i_Out,'(a)')
     +      ' => March model for preferred orientation'
      IF (NORI.EQ.2) WRITE(i_Out,'(a)')
     +      ' => Pecharskii model for preferred orientation'
      IF(IWGT.EQ.1) WRITE(i_Out,'(a)')
     +      ' => Maximum Likelihood weighting scheme'
      IF(IWGT.EQ.2) WRITE(i_Out,'(a)')
     +      ' => Unit weights will be applied'
      IF(IASYM.EQ.0) WRITE(i_Out,'(a)')
     +      ' => Asymmetry correction as in J.Appl.Cryst. 26,128(1993)'
      IF(IASYM.EQ.1) WRITE(i_Out,'(a)')
     +      ' => Asymmetry correction as in J.Appl.Cryst. 15,615(1982)'
c
      IF(NBCKGD-1.lt.0) THEN
        WRITE(i_Out,'(a)')
     +            ' => Background refined by polynomial function'
      Else IF(NBCKGD-1.eq.0) THEN
        IF(ISBAC.EQ.1) THEN
          WRITE(i_Out,'(a)') ' => Background read from file'
        Else      !   input NBCKGD ---> (-1)
          WRITE(i_Out,'(a)')
     +  ' => Background refined by Debye-like and Polynomial functions'
        End If
      Else IF(NBCKGD-1.eq.1.and.isbac.eq.-1) THEN
          WRITE(i_Out,'(a)')
     +    ' => Background adjusted by Fourier filtering '
         IPL=2
      Else
        IF(ISBAC.EQ.-1) THEN
          WRITE(i_Out,'(a,i4,a)')
     +    ' => Background interpolated by cubic splines'//
     +    ' between the ',NBCKGD,' points given'
        Else
          WRITE(i_Out,'(a,i4,a)')
     +    ' => Background linearly interpolated'//
     +    ' between the ',NBCKGD,' points given'
        End If
      End If
C
      WRITE(i_Out,30) NPROF-1
      WRITE(i_Sum,30) NPROF-1
  30  FORMAT(' => The '  ,I4,'th default profile function was selected')
      IF(NPROF.EQ.5) then
       WRITE(i_Out,'(a/a/a/a)')
     + ' => Tripled pseudo-Voigt function (ETA unique)',
     + '      p4(x) = X*pV(x-D) + (1-X-Y)*pV(x) + Y*pV(x+D) ',
     + '          D = Shp1*tan(theta)      ',
     + '      pV(x) = ETA*L(x)+(1-ETA)*G(x)'
      elseIF(NPROF.EQ.6) then
       WRITE(i_Out,'(a/a/a)')
     + ' => Pseudo-Voigt function (ETA variable)',
     + '                 X-parameter correspond to: ETA=ETA0+X*2theta',
     + '                       pV(x)= ETA*L(x)+(1-ETA)*G(x)'
      elseIF(NPROF.EQ.7) then
       WRITE(i_Out,'(a/a/a)')
     +      ' => Normalized Pearson VII (m exponent variable)',
     +      '                 X and Y parameters correspond to:',
     +      '                m=m0+100*X/2theta+10000*Y/2theta**2 '
      elseIF(NPROF.EQ.9) then
       WRITE(i_Out,'(a)')
     +      ' => Numerical profile provided by user in file GLOBAL.SHP'
      elseIF(NPROF.EQ.10) then
       WRITE(i_Out,'(a/a/a)')
     +' => T.O.F Profile Function #1 ',
     +'    Decay Exponential convoluted with Gaussian: ',
     +'    Omega(DT) = N {Exp(u).Erfc(y)+ Exp(v).Erfc(z)}  '
      elseIF(NPROF.EQ.11) then
       WRITE(i_Out,'(a/a/a/a)')
     +' => T.O.F Profile Function #2 ',
     +'    Decay Exponential convoluted with pseudo-Voigt:',
     +'    Omega(DT) = (1-eta)N {Exp(u).Erfc(y)+ Exp(v).Erfc(z)} +  ',
     +'                2N eta/pi{-Im[Exp(p)E1(p)]-Im[Exp(q)E1(q)]}  '
      elseIF(NPROF.EQ.12) then
       WRITE(i_Out,'(a/a/a/a/a/a)')
     +' => Split pseudo-Voigt function ',
     +'    For x<=0 eta and FWHM (H) are different than for x>0',
     + '     x<=0    pV(x)= {ETAl*L(x,Hl)+(1-ETAl)*G(x,Hl)}/(N/4)',
     + '     x>0     pV(x)= {ETAr*L(x,Hr)+(1-ETAr)*G(x,Hr)}/(N/4)',
     + '   L(x,H)=1/{1+4*(x/H)^2};  G(x,H)= exp{-4Ln2*(x/H)^2}',
     + '   N ={Hl*((pi-a)*ETAl+a)+Hr*((pi-a)*ETAr+a)}; a=sqrt(pi/Ln2)'
      elseIF(NPROF.EQ.13) then
       WRITE(i_Out,'(10(a/))')
     + ' => Pseudo-Voigt function (ETA variable)',
     + '                 X-parameter correspond to: ETA=ETA0+X*2theta',
     + '                       pV(x)= ETA*L(x)+(1-ETA)*G(x)',
     +'    This function is convoluted with asymmetry due to axial ',
     +'    divergence as formulated by: ',
     +'    van Laar and Yelon, J. Appl. Cryst. 17, 47(1984).',
     +'    and using the method of:',
     +'    Finger, Cox and Jephcoat, J. Appl. Cryst. 27, 892 (1992).',
     +'    Fortran code adapted from PROFVAL: ',
     +'    L.W. Finger, J. Appl. Cryst. (1997), in press.'
       endif
      endif !End of if(ICRYG.eq.0)
C
C
C------------------------------------------------------- FORMAT(BZ,17I1)
      FMTfields = 'iiiiiiiiiiiiiiiii'
      Line_Nb = Line_Nb +1
      Call FindFMT(i_Pcr,aLine,FMTfields,FMTformat,nCarL,iErr)
      if (iErr.eq.-1) GoTo 99999
      if (iErr.ne.0)  GoTo 99995
      READ(aLine,FMTformat)
     +      IOT,IPL,IPC,MAT,NXT,LST1,LST2,LST3,IPL1,IPL2,
     +  INSTR,JCIL,JSY,JLKH,JFOU,ISHOR,IANALY
C-----------------------------------------------------------------------
       if(ICRYG.eq.2) then
         IOT=0
         IPL=0
         IPC=1
         MAT=0
         LST1=0
         LST2=0
         LST3=0
         IANALY=0
         ISHOR=0
         JLKH=0
       endif
C-----------------------------------------------------------------------
c  Determine if the run is CYCLIC or not
c-----------------------------------------------------------------------
      IF(L_cyclic.eq.1) THEN
       IF(JCIL.eq.0) JCIL=1
       JSY=0
       IOT=0
       IPL=0
       IPC=0
       MAT=0
       NXT=1
       LST1=0
       LST2=0
       LST3=0
       IPL1=0
       IPL2=0
       JLKH=0
       JFOU=0
       ISHOR=1
       IANALY=0
      ENDIF
c----- Opening files .SYM and RPA
      IF (JSY.GT.0) call Openfile(3,0,1)
      IF (JCIL.GT.0)call Openfile(4,0,1)
C
      WRITE(i_Out,'(/a/)') ' ==> INPUT/OUTPUT OPTIONS:'
      IF (JSY.EQ.1)  WRITE(i_Sym,'(1x,a70)') TITLE
      IF (JCIL.EQ.1) then
        WRITE(i_rpa,'(a,a70)')'TITL ', TITLE
        lon1=lenstr(filedat)
        lon2=lenstr(filenam)
        WRITE(i_rpa,'(a,a,a,a)')'FILES => DAT-file: ',filedat(1:lon1),
     +   ',  PCR-file: ',filenam(1:lon2)
        WRITE(i_rpa,'(a,a)')'DATE & TIME ',dat_tim
        WRITE(i_rpa,'(a,a)') 'REM  ',
     +  ' JOBTYP   NPROF  NPHASE  NBCKGD  NEXCRG   NSCAT    NORI'
        WRITE(i_rpa,'(a,7(I5,3X))') 'GLB1 ',
     +      JOBTYP,NPROF-1,NPHASE,NBCKGD,NEXCRG,NSCAT,NORI

        WRITE(i_rpa,'(a,a)') 'REM  ',
     +'  IDUM    IWGT    ILOR    IASG    IRESO   ISTEP    NRELL  ICRYG'
        WRITE(i_rpa,'(a,8(I5,3X))') 'GLB2 ',
     +      IDUM,IWGT,ILOR,IASG,IRESO,ISTEP,NRELL,ICRYG

        WRITE(i_rpa,'(a,a)') 'REM  ',
     +' IOT   IPL   IPC   MAT   NXT  LST1  LST2  LST3  IPL1  IPL2'
        WRITE(i_rpa,'(a,10(i4,2X))') 'OUT1 ',
     +      IOT,IPL,IPC,MAT,NXT,LST1,LST2,LST3,IPL1,IPL2

        WRITE(i_rpa,'(a,a)') 'REM  ',
     +' INSTR  JCIL  JSY  JLKH  JFOU ISHOR IANALY'
        WRITE(i_rpa,'(a,7(i4,2X))') 'OUT2 ',
     +  INSTR,JCIL,JSY,JLKH,JFOU,ISHOR,IANALY
      endif
      DRES = 3.5
      IF (JSY.EQ.1)  WRITE(i_Sym,'(i5,f8.4)') IPL1,DRES
      if(icryg.eq.0) then
      IF(IOT.NE.0)   WRITE(i_Out,'(a)')
     +      ' => Output Obs and Calc intensities on last cycle'
      IF(IPL.NE.0)   WRITE(i_Out,'(a)')
     +      ' => Generate line printer plot'
      IF(IPL2.NE.0)  WRITE(i_Out,'(a)')
     + ' => Generate file *.PRF for plot'
      IF(IPC.NE.0)   WRITE(i_Out,'(a)')
     +      ' => Output Integrated Intensities'
      IF(LST1.NE.0)  WRITE(i_Out,'(a)')
     +      ' => Print reflection list'
       endif

      IF(MAT.NE.0.AND.iabs(JOBTYP).LT.2) WRITE(i_Out,'(a)')
     +  ' => Output Correlation Matrix'
      IF(NXT.NE.0) WRITE(i_Out,'(a)')
     +      ' => Generate new input file *.PCR'
C
c++++++++++++++++++++++++++++++++++++++++
       if(ICRYG.eq.0) then
c++++++++++++++++++++++++++++++++++++++++
      IF (INSTR.EQ.0) THEN
        WRITE(i_Out,40)
        WRITE(i_Sum,40)
      Else IF (INSTR.EQ.1) THEN
        WRITE(i_Out,50)
        WRITE(i_Sum,50)
      Else IF (INSTR.EQ.2) THEN
        WRITE(i_Out,60)
        WRITE(i_Sum,60)
      Else IF (INSTR.EQ.3) THEN
        WRITE(i_Out,70)
        WRITE(i_Sum,70)
      Else IF (iabs(INSTR).EQ.4) THEN
        WRITE(i_Out,80)
        WRITE(i_Sum,80)
      Else IF (INSTR.EQ.5) THEN
        WRITE(i_Out,90)
        WRITE(i_Sum,90)
      Else IF (INSTR.EQ.6) THEN
        WRITE(i_Out,100)
        WRITE(i_Sum,100)
      Else IF (INSTR.EQ.7) THEN
        WRITE(i_Out,110)
        WRITE(i_Sum,110)
      Else IF (INSTR.EQ.8) THEN
        WRITE(i_Out,120)
        WRITE(i_Sum,120)
      Else IF (INSTR.EQ.9) THEN
       WRITE(i_Out,125)
       WRITE(i_Sum,125)
      Else IF (INSTR.EQ.10) THEN
       WRITE(i_Out,126)
       WRITE(i_Sum,126)
      Else IF (INSTR.EQ.11) THEN
       WRITE(i_Out,127)
       WRITE(i_Sum,127)
      Else
        WRITE(i_Sum,'(A)') ' => Invalid INSTR parameter!!!'
      End If
   40 FORMAT(1X,'=> Data supplied in free format ')
   50 FORMAT(1X,'=> Data in D1A,D2B (ILL) format ')
   60 FORMAT(1X,'=> Data in D1B(ILL) format, Step=0.2 in 2theta')
   70 FORMAT(1X,'=> Data in D1B,D20 format')
   80 FORMAT(1X,'=> Data in BNBL(Synchrotron) format')
   90 FORMAT(1X,'=> Data in GENERAL FORMAT for TWO AXIS instrument ')
  100 FORMAT(1X,'=> Data in D1A,D2B format as prepared by D1A(D2B)SUM ')
  110 FORMAT(1X,'=> Data in D4,D20L format')
  120 FORMAT(1X,'=> Data in DMC format at Wurenlingen ')
  125 FORMAT(1X,'=> UXD data from Socabim Eva-2 Software ')
  126 FORMAT(1X,'=> X-Y type of data: 2theta/TOF Intens sigma')
  127 FORMAT(1X,'=> Variable time data collection (format as LPHM)')
C
      IF(NPHASE.EQ.1)LST3=0
      IF(LST3.NE.0)WRITE(i_Out,'(a)') ' => Print merged reflection list'
      IF(LST2.EQ.1)WRITE(i_Out,'(a)') ' => Print corrected data'
      IF(LST2.EQ.2)WRITE(i_Out,'(a)') ' => Pot pattern at each cycle'
      if(IANALY.EQ.1)WRITE(i_Sum,'(a)')
     +            ' => Analysis of refinement at the end'
C
C
C-------------------------------------------------------FORMAT(BZ,9F8.0)
      FMTfields = 'fffffffff'
      Line_Nb = Line_Nb +1
      Call FindFMT(i_Pcr,aLine,FMTfields,FMTformat,nCarL,iErr)
      if (iErr.eq.-1) GoTo 99999
      if (iErr.ne.0)  GoTo 99995
      READ(aLine,FMTformat)
     +      LAMDA,RATIO(2),BKPOS,WDT,CTHM,TMV,RLIM,RKK
C-----------------------------------------------------------------------
C
      IUVW=0
      if(ratio(2).lt.0.0) then
       iuvw=1
       ratio(2)=-ratio(2)
      endif
      WRITE(i_Out,'(a,2F8.5)') ' => Wavelengths: ',LAMDA
      WRITE(i_Sum,'(a,2F8.5)') ' => Wavelengths: ',LAMDA
C
      RATIO(1)=1.
      WRITE(i_Out,'(a,f8.4)') ' => Alpha2/Alpha1 ratio: ',RATIO(2)
      if(iuvw.eq.1) then
        WRITE(i_Out,'(a)')
     +  ' => Different U,V,W parameters for Lambda(2) will be read'
      endif
      WRITE(i_Out,'(a,f8.2)') ' => Base of peaks: 2.0*HW*',WDT
      WRITE(i_Sum,'(a,f8.2)') ' => Base of peaks: 2.0*HW*',WDT
C
      IF (INSTR.EQ.4) THEN
        WRITE(i_Out,'(a,F8.4/a,F8.4)')
     +    ' => Cos(Monochromator angle)= ',CTHM,
     +    ' => Polarization= ',RKK
        WRITE(i_Sum,'(a,F8.4/a,F8.4)')
     +    ' => Cos(Monochromator angle)= ',CTHM,
     +    ' => Polarization= ',RKK
      Else
        WRITE(i_Out,'(a,f8.4)') ' => Cos(Monochromator angle)= ',CTHM
        WRITE(i_Sum,'(a,f8.4)') ' => Cos(Monochromator angle)= ',CTHM
      END IF
C
      WRITE(i_Out,'(a,f8.4)')' => Absorption correction (muR-eff): ',TMV
      WRITE(i_Sum,'(a,f8.4)')' => Absorption correction (muR-eff): ',TMV
      WRITE(i_Out,'(a,f8.3,a)')
     +      ' => Asymmetry correction for angles lower than ',RLIM,
     +      ' degrees'
       else
       RATIO(1)=1.0
       RATIO(2)=0.0
c++++++++++++++++++++++++++++++++++++++++
      endif !         if(ICRYG.eq.0) then
c++++++++++++++++++++++++++++++++++++++++
C
C
C--------------------------------------------- FORMAT(BZ,I4,5F4.0,4F8.0)
      FMTfields = 'iffffffffff'
      Line_Nb = Line_Nb +1
      Call FindFMT(i_Pcr,aLine,FMTfields,FMTformat,nCarL,iErr)
      if (iErr.eq.-1) GoTo 99999
      if (iErr.ne.0)  GoTo 99995
      READ(aLine,FMTformat)
     +      MCYCLE,EPS,RELAX,THMIN,STEP,THMAX,ALPSD,SENT0
C-----------------------------------------------------------------------
C
      IF(iabs(JOBTYP).GT.1.or.icryg.eq.2) MCYCLE=1
      WRITE(i_Out,'(a,i4)') ' => Number of cycles: ',MCYCLE
      if(ICRYG.eq.0) then
      WRITE(i_Out,'(a,a,f5.2/a,f5.2/a,f5.2/a,f5.2)')
     + ' => Relaxation factors ==>',
     + '    for coordinates: ',RELAX(1),
     + ' => for anisotropic temperature factors: ',RELAX(2),
     + ' => for halfwidth/strain/size parameters: ',RELAX(3),
     + ' => for lattice constants and propagation vectors: ',RELAX(4)
       elseif(icryg.eq.1) then   !Icryg
      WRITE(i_Out,'(a,a,f5.2/a,f5.2)')
     + ' => Relaxation factors ==>',
     + '    for coordinates: ',RELAX(1),
     + ' => for anisotropic temperature factors: ',RELAX(2)
       endif  !Icryg
      if(icryg.ne.2)
     + WRITE(i_Out,'(a,f6.1)') ' => EPS-value for convergence: ',EPS
      IF(SENT0.GT.0.0.AND.(ILOR.EQ.0.or.ILOR.eq.3).AND.I_RAY.EQ.1)
     + WRITE(i_Out,'(A,f8.2)')
     +' => Low angle scale factor multiplied by sin(theta)/sin(t0), wher
     +e t0=',SENT0
C
c++++++++++++++++++++++++++++++++++++++++
       if(ICRYG.eq.0) then
c++++++++++++++++++++++++++++++++++++++++
      IF(NBCKGD.ge.2.and.(.not.read_bac)) THEN
C     ------------------------------------------------- FORMAT(BZ,2F8.2)
        FMTfields = 'ff'
        DO I=1,NBCKGD
          Line_Nb = Line_Nb +1
          Call FindFMT(i_Pcr,aLine,FMTfields,FMTformat,nCarL,iErr)
          if (iErr.eq.-1) GoTo 99999
          if (iErr.ne.0)  GoTo 99995
          READ(aLine,FMTformat) POS(I),BCK(I)
        END DO
C     ------------------------------------------------------------------
C
        WRITE(i_Out,'(a/a/20(2f12.2,/))')
     +    ' => Background ==> ','    Position   Intensity',
     +    (POS(I),BCK(I),I=1,NBCKGD)
      End If
C
      IF (NEXCRG.GT.0) Then
C     ------------------------------------------------- FORMAT(BZ,2F8.2)
        FMTfields = 'ff'
        DO I=1,NEXCRG
          Line_Nb = Line_Nb +1
          Call FindFMT(i_Pcr,aLine,FMTfields,FMTformat,nCarL,iErr)
          if (iErr.eq.-1) GoTo 99999
          if (iErr.ne.0)  GoTo 99995
          READ(aLine,FMTformat) ALOW(I),AHIGH(I)
        END DO
C     ------------------------------------------------------------------
        WRITE(i_Out,'(a/a/20(2F9.4,/))')
     +    ' => Excluded regions ==>','    From     to',
     +    (ALOW(I),AHIGH(I),I=1,NEXCRG)
      End If
c++++++++++++++++++++++++++++++++++++++++
       endif    !if(ICRYG.eq.0) then
c++++++++++++++++++++++++++++++++++++++++
C
C***********************************************************************
C************** Scattering factors supplied by user ********************
C***********************************************************************
C
      IF (NSCAT.EQ.0) GOTO 170
      ITYMAG=0

      DO 160 I=1,NSC
C     ------------------------------------------- FORMAT(BZ,A4,2F8.0,I4)
        FMTfields = '4ffi'
        Line_Nb = Line_Nb +1
        Call FindFMT(i_Pcr,aLine,FMTfields,FMTformat,nCarL,iErr)
        if (iErr.eq.-1) GoTo 99999
        if (iErr.ne.0)  GoTo 99995
        READ(aLine,FMTformat) NAM(I),DFP(I),DFPP(I),ITY(I)
C     ------------------------------------------------------------------
C
        ITYMAG=ITYMAG+ITY(I)
        IF(iabs(JOBTYP).EQ.1.OR.iabs(JOBTYP).EQ.3) THEN
          IF(ITY(I).EQ.0) GOTO 160          !Neutron case, Fermi length
        ELSE
          IF(ITY(I).EQ.0) call LowerCase(NAM(i))   !X-rays
        End If
          IF(ITY(I).EQ.2) then
           Call Look_for(I)
           GOTO 160
          endif
        K=1
C
C     --- Read scattering factor as coeffs or table for fitting coeff.
        IF(NSCAT.gt.0) THEN
          K=0
C       ----------------------------------------------- FORMAT(BZ,9F8.0)
          FMTfields = 'fffffffff'
  140     Line_Nb = Line_Nb +1
          Call FindFMT(i_Pcr,aLine,FMTfields,FMTformat,nCarL,iErr)
          if (iErr.eq.-1) GoTo 99999
          if (iErr.ne.0)  GoTo 99995
          READ(aLine,FMTformat) (AC(J,I),J=1,9)
C       ----------------------------------------------------------------
C
          IF(AC(1,I)+100. .lt.1.e-04) CALL COEF(I,K)
          IF(abs(AC(3,I)).gt.1.e-06) GOTO 160
          K=K+1
          POSI(K)=AC(1,I)
          SCAT(K)=AC(2,I)
          IF(K.LE.N_form-1) GOTO 140
          WRITE(i_Out,'(a)') ' => Too many scattering factor entries'
          CALL STOP_COND(' Too many scattering factor entries ',1)
           else
C
C     --- Read scattering factor for linear interpolation.
C
C       ----------------------------------------------- FORMAT(BZ,9F8.0)
        FMTfields = 'ff'
  150   Line_Nb = Line_Nb +1
        Call FindFMT(i_Pcr,aLine,FMTfields,FMTformat,nCarL,iErr)
        if (iErr.eq.-1) GoTo 99999
        if (iErr.ne.0)  GoTo 99995
        READ(aLine,FMTformat) STAR(K,I),AC(K,I)
C       ----------------------------------------------------------------
C
        IF(.not.(abs(STAR(K,I)+100.).lt.1.e-04)) Then
          K=K+1
          IF(K.LE.N_form-1) goto 150
        End If
        NPSC(I)=K-1
        ENDIF    !IF(NSCAT.gt.0) THEN
C
  160 CONTINUE      ! DO 160 I=1,NSC
C
      IF(JOBTYP.EQ.0 .or. JOBTYP.EQ.2 .or. ITYMAG.ne.0) Then
c
      WRITE(i_Out,'(a)') ' => Scattering factors ==>'
      IF(NSCAT.GT.0) THEN
        WRITE(i_Out,
     +    '('' -> For '',A4,'' Dfp='',F10.6,'' Dfpp='',F10.6,/,
     +      ''    Coefficients: '',9F10.6)')
     +    (NAM(I),DFP(I),DFPP(I),(AC(J,I),J=1,9),I=1,NSC)
      Else
        WRITE(i_Out,'(/A/)')'     *(Tables for Linear Interpolation)*'
        DO I=1,NSC
          WRITE(i_Out,
     +      '('' => For '',A4,'' Dfp='',F10.6,'' Dfpp='',F10.6,/,
     *        '' =>  R*=1000/d       F(R*)   ''/)')
     +      NAM(I),DFP(I),DFPP(I)
          DO K=1,NPSC(I)
            WRITE(i_Out,'(2(4X,F10.5))') STAR(K,I),AC(K,I)
          END DO
          WRITE(i_Out,'(A)') ' '
        END DO
      End If
c
      ELSE
C
        WRITE(i_Out,'(a)') ' => Scattering lengths ==>'
        WRITE(i_Out,'(5H For ,a4,1x,f10.6)')
     +    (NAM(I),DFP(I),I=1,NSC)
        DO I=1,NSC
          DO J=1,9
            AC(J,I)=0.
          End Do
          DFPP(I)=0.
        End Do
      ENDIF !     IF(JOBTYP.EQ.0 .or. JOBTYP.EQ.2 .or. ITYMAG.ne.0)
C
  170 CONTINUE      ! IF(NSCAT.EQ.0)

      Call Read_news2(read_bac,nsc)
      return
C
99999 CALL STOP_COND(' End of file *.PCR ',1)
99997 CALL STOP_COND(' End of file *.BAC ',1)
99995 Call FindFMT_Err(iErr,aLine,nCarL)
      Call message(' Please check your *.PCR file at line: ',Line_Nb,
     + 0.0,1)
      CALL STOP_COND(' Format error ',1)
C
      END                                          !   Subroutine READNEWS
C--------1---------2---------3---------4---------5---------6---------7--
      Subroutine Read_PhasesCond(K,N)
C--------1---------2---------3---------4---------5---------6---------7--
      INCLUDE      'ful0.inc'
      INCLUDE      'ful1.inc'
      INCLUDE      'ful2.inc'
cfree
      Character    aLine*132,FMTformat*132,FMTfields*80,text80*80
      Integer*4    nCarL,iErr,Line_Nb
      common/Line_count/Line_Nb
      logical mag
cfree
C
      COMMON      /SPG/
     +      NSPGRP,NSP(1),NCONT(10),FILL(1),ICE,MULTG
      COMMON      /BLNK1/
     +      NJNK(22),FILL2(751)
      CHARACTER      SPG(20)*1
C---------------
C-------------------------------------------------------- FORMAT(BZ,A70)
        Line_Nb = Line_Nb +1
    1   Read(i_Pcr,'(BZ,a70)',END=99999) PHSNM(K)
        if(PHSNM(K)(1:1).eq.'!') goto 1
C-----------------------------------------------------------------------
C
        WRITE(i_Out,14) ' => Phase  No.',K,'      ',PHSNM(K)
   14   format(1x,80('-')/a,i2/a,a70/1x,80('-'))
C
C------------------------------------- FORMAT(BZ,3I4,3F4.0,5I4,F12.0,3I4)
        FMTfields = 'iiifffiiiiifiii'
        Line_Nb = Line_Nb +1
        Call FindFMT(i_Pcr,aLine,FMTfields,FMTformat,nCarL,iErr)
        if (iErr.eq.-1) GoTo 99999
        if (iErr.ne.0)  GoTo 99995
        READ(aLine,FMTformat)
     +    NATOM(K),NDIC(K),NMAGC(K),(PREF(K,I),I=1,3),
     +    JBT(K),IRF(K),ISYM(K),ISTR(K),IFURT(K),ATZ(K),NVK(K),NPRO(K),
     +    IMORE(K)
         if(iabs(IRF(K)).eq.4) ICRY=1
         if(iabs(IRF(K)).ne.4.and.ICRYG.ne.0) IRF(K)=4
         mag=iabs(jbt(k)).eq.1 .or.iabs(jbt(k)).eq.10
C-----------------------------------------------------------------------
        IF(IMORE(K).NE.0) THEN
         FMTfields = 'iiiiiiffffi'
         Line_Nb = Line_Nb +1
         Call FindFMT(i_Pcr,aLine,FMTfields,FMTformat,nCarL,iErr)
         if (iErr.eq.-1) GoTo 99999
         if (iErr.ne.0)  GoTo 99995
         READ(aLine,FMTformat) JVIEW(K),JDIST(K),JHELIX(K),JSOL(K),
     +   JMOM(K),JTER(K),BRINL(K),RMUA(K),RMUB(K),RMUC(K),JTYP(K)
        ENDIF
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C
        IF(JSOL(K).EQ.1.AND.IRF(K).EQ.1) JFOU=0
        IF(iabs(IRF(k)).eq.4) JSOL(k)=0
        IF(iabs(IRF(k)).eq.4.and.rmua(k).lt.1.0e-05) rmua(k)=1.0
        IF(BRINL(K).LT.1.E-15) BRINL(K)=1.0
        NPRO(K)=NPRO(K)+1
        IF(NPRO(K).EQ.1) NPRO(K)=NPROF
        IF(NDIC(K).NE.0 .OR. NMAGC(K).NE.0) SLCONS=.TRUE.
        GENK(K)='N'
        IF(NVK(K).LT.0) THEN
          GENK(K)='Y'
          NVK(K)=IABS(NVK(K))
        End If

        if(IMore(k).eq.0) then
          Jtyp(k)=JOBTYP
        else
           text80=' '
          if(jview(k).eq.1) then
           text80=' => Schakal File (*.sch) is output for phase:'
          elseif(jview(k).eq.2) then
           text80=' => STRUPLO File (*.sch) is output for phase:'
          elseif(jview(k).eq.11) then
           text80=
     +    ' => Clusters of overlaped reflections is output for phase:'
          endif
           Lo=LenStr(text80)
          IF(Lo.NE.0) then
            WRITE(i_Out,'(A,i2)')text80(1:Lo),K
            WRITE(i_sum,'(A,i2)')text80(1:Lo),K
          ENDIF

          if(jtyp(k).eq.0.and.mag) jtyp(k)=1
          if(Jtyp(k).ne.jobtyp) then
          text80=' => Different job for phase: '
          Lo=LenStr(text80)
            WRITE(i_Out,'(A,i2)')text80(1:Lo),K
            WRITE(i_sum,'(A,i2)')text80(1:Lo),K
                if(Jtyp(k).eq.0) then
                 text80='    X-ray diffraction data'
                 WRITE(i_Out,'(A)') text80
                 WRITE(i_sum,'(A)') text80
                Elseif(Jtyp(k).eq.1) then
                 text80='    Neutron diffraction data'
                 WRITE(i_Out,'(A)') text80
                 WRITE(i_sum,'(A)') text80
                Elseif(Jtyp(k).eq.-1) then
                 text80='    Neutron T.O.F. diffraction data'
                 WRITE(i_Out,'(A)') text80
                 WRITE(i_sum,'(A)') text80
                endif
          endif
         endif
        if(iabs(IRF(k)).eq.4) then
        ISTR(k)=0
        text80=' => Integrated intensities as observations for phase: '
          Lo=LenStr(text80)
          WRITE(i_Out,'(A,i2)')text80(1:Lo),K
          WRITE(i_sum,'(A,i2)')text80(1:Lo),K
          if(IRF(k).eq.-4) then
        text80='    Partial Structure Factors, Fp=A+iB, read from file'
          Lo=LenStr(text80)
          WRITE(i_Out,'(A)')text80(1:Lo)
          WRITE(i_sum,'(A)')text80(1:Lo)
          endif
        endif

C
C------------------------------------------------------- FORMAT(BZ,20A1)
        Line_Nb = Line_Nb +1
    2   READ(i_Pcr,'(BZ,20a1,a)',END=99999) (SYMB(K,I),I=1,20),
     +                   text80(1:10)
        if(symb(k,1).eq.'!') goto 2
C-----------------------------------------------------------------------
C
         Mag_GRP(K)=0
        IF(iabs(JBT(K)).EQ.10) THEN
         do j=1,8
          if(text80(j:j+2).eq.'Mag')  Mag_GRP(K)=1
         end do
        ENDIF
        IF(iabs(JBT(K)).EQ.2 .OR. iabs(JBT(K)).EQ.3) THEN
          NATOM(K)=0
          IF(iabs(JBT(K)).EQ.2) THEN
            IASG=1
            IF(IDUM.EQ.0) IDUM=1
            IF(iabs(JOBTYP).GT.1) THEN
      CALL STOP_COND(' Pattern Matching does not work with JOBTYP>1 ',1)
            End If
          End If
        End If
C
        IF(JBT(K).EQ.0) THEN
          WRITE(i_Out,'(A)')
     +      ' => Crystal Structure Refinement'
          WRITE(i_Sum,'(A,I2)')
     +      ' => Crystal Structure Refinement for phase:',K
        End If
C
        IF(iabs(JBT(K)).EQ.4) THEN
          WRITE(i_Out,'(A)')
     +      ' => Structural model provided by user'
          WRITE(i_Sum,'(A,I2)')
     +      ' => Structural model provided by user for phase:',K
          CALL Comments4(K)
        End If
C
        IF(JBT(K).EQ.1) THEN
          WRITE(i_Out,'(A)')
     +      ' => Magnetic Structure Refinement'
          WRITE(i_Sum,'(A,I2)')
     +      ' => Magnetic Structure Refinement for phase:',K
        End If
C
        IF(JBT(K).EQ.-1) THEN
          WRITE(i_Out,'(A)')
     +      ' => Magnetic Structure Refinement (Spherical)'
          WRITE(i_Sum,'(A,A,I2)')
     +      ' => Magnetic Structure Refinement (Spherical)',
     +          ' for phase:',K
        End If
C
        IF(iabs(JBT(K)).EQ.10) THEN
        text80=' => Crystal+Magnetic Structure Refinement'
        if(jbt(k).lt.0)
     +   text80=' => Crystal+Magnetic(Spherical) Structure Refinement'
        Lo=lenstr(text80)
          WRITE(i_Out,'(A)') text80(1:lo)
          WRITE(i_Sum,'(A,a,I2)') text80(1:lo),' for phase:',K
        End If
         IF(mag.and.JHELIX(K).EQ.1) THEN
          WRITE(i_Out,'(A/a)')
     +' => Fourier coefficients: S=1/2 (m1 u+ i m2 v), with u.v=0',
     +'    ( -> M3(imag) or Phi(imag) is calculated to satisfy u.v=0 )'
          WRITE(i_Sum,'(A,I2)')
     +' => Fourier coefficients: S=1/2 (m1 u+ i m2 v), with u.v=0'
         ENDIF
c
        IF(iabs(JBT(K)).EQ.5)THEN
          WRITE(i_Out,'(A)')
     +      ' => Magnetic model provided by user'
          WRITE(i_Sum,'(A,I2)')
     +      ' => Magnetic model provided by user for phase:',K
          CALL Comments5(K)
        End If
C
        IF(iabs(JBT(K)).EQ.2)THEN
          WRITE(i_Out,'(A)')
     +      ' => Pattern Matching (fixed scale)'
          WRITE(i_Sum,'(A,I2)')
     +      ' => Pattern Matching (fixed scale) for phase:',K
          IRIT=0
          If(jbt(k).eq.2) write(i_out,'(a)')
     +                    ' => Input data: Integrated Intensities'
          If(jbt(k).eq.-2) write(i_out,'(a)')
     +                    ' => Input data: F(H)^2'
        End If
C
        IF(iabs(JBT(K)).EQ.3)THEN
          WRITE(i_Out,'(A)')
     +      ' => Pattern Matching (variable scale)'
          WRITE(i_Sum,'(A,I2)')
     +      ' => Pattern Matching (variable scale) for phase:',K
          If(jbt(k).eq.3) write(i_out,'(a)')
     +                    ' => Input data: Integrated Intensities'
          If(jbt(k).eq.-3) write(i_out,'(a)')
     +                    ' => Input data: F(H)^2'
        End If
C
        IF(iabs(JBT(K)).EQ.3.AND.IRF(K).NE.2) THEN
      call message('  Illegal JBT and IRF for phase:',K,0.0,1)
      call mess('  If iabs(JBT)=3 then IRF must be = 2')
      CALL STOP_COND(' Illegal JBT and IRF ',1)
        End If
C
      if(irf(k).eq.3) write(i_out,'(a)')
     *' => Reflection list & partial structure factors read from file'
c
        IF(NPRO(K).NE.NPROF.and.iabs(IRF(K)).NE.4) THEN
       WRITE(i_Out,'(A,I4,A,I2)') ' => The ',NPRO(K)-1,'th profile'//
     +  ' function was selected for phase no. ',K
       WRITE(i_Sum,'(A,I4,A,I2)') ' => The ',NPRO(K)-1,'th profile'//
     +  ' function was selected for phase no. ',K
        ENDIF

        N=NATOM(K)
        WRITE(i_Out,'(a,i4/a,i4/a,i4/a,3f8.4)')
     +    ' => Number of atoms: ',N,
     +    ' => Number   of   distance    constraints: ',NDIC(K),
     +    ' => Number of magnetic moment constraints: ',NMAGC(K),
     +    ' => Preferred orientation vector: ',(PREF(K,I),I=1,3)
C*I
        IF(GENK(K).EQ.'N') THEN
          WRITE(i_Out,'(/a,i3)')
     +      ' => Number of propagation vectors [K] = ', NVK(K)
        Else
          WRITE(i_Out,'(/A/)')
     +      ' => The list of [K] vectors has been'//
     +      ' augmented with [-K]'
          WRITE(i_Out,'(/a,i3)')
     +      ' => Number of propagation vectors [K]+[-K] = ',2*NVK(K)
        End If
C*F
C
        DO I=1,20
          SPG(I)=SYMB(K,I)
        End Do
        IF(ISYM(K).EQ.0) CALL SPGP(SPG,0)
        numspg(k)=nspgrp
C
C phase ****************************************************************
C phase *** READ SYMMETRY OPERATORS IF ISYM(K)=1 IN RTMT
C phase *** THE VECTORS IVEC(K,I) ARE CONSTRUCTED AT THE SAME TIME
C phase ****************************************************************
C
        NLATTI(K)=1
        IF(ISYM(K).EQ.0) CALL OP1
        IF(iabs(JBT(K)).lt.2.or.iabs(JBT(K)).gt.3) CALL RTMT(K,SPG)
C
C  If the symmetry operators are supplied by user the reflections are
C  generated with the supplied space group symbol.
C  After the first run with IRF(k)=0 or -1 a file with independent
C  reflections and proper multiplicities is created. The file is
C  valid only for the model used in the first run.
C
      IF( (ISYM(K).NE.0) .AND. (IRF(K).le.0).and.(IRF(K).ne.-4)) THEN
       CALL SPGP(SPG,isym(k))
       CALL OP1
      ENDIF
      return
99999 CALL STOP_COND(' End of file *.PCR ',1)
99995 Call FindFMT_Err(iErr,aLine,nCarL)
      Call message(' Please check your *.PCR file at line: ',Line_Nb,
     + 0.0,1)
      CALL STOP_COND(' Format error ',1)
      end
c-----------------------------------------------------------------------------
      Subroutine Read_news2(read_bac,nsc)
      INCLUDE      'ful0.inc'
      INCLUDE      'ful1.inc'
      INCLUDE      'ful2.inc'
cfree
      Character    aLine*132,FMTformat*132,FMTfields*80
      Integer*4    nCarL,iErr,Line_Nb,ioff,ini
      common/Line_count/Line_Nb
cfree
C
      COMMON      /FORMATO/
     +      INSTR,NUMOR,TSAMP
      COMMON      /SPG/
     +      NSPGRP,NSP(1),NCONT(10),FILL(1),ICE,MULTG
      COMMON      /BLNK1/
     +      NJNK(22),FILL2(751)
C
      COMMON      /CELLX/
     +      AA,B,C,ALPHA,BETA,GAMMA,AL(3,3),IMU
C
      DIMENSION BACK(6),FBACK(6),Y2D(IBACP)
      LOGICAL read_bac
      EQUIVALENCE (GLB(1),ZER),(GLB(2),BACK(1))
      EQUIVALENCE (GLB(8),DISP),(GLB(9),TRANSP)
      EQUIVALENCE (AGLB(1),FLGZER),(AGLB(2),FBACK(1))
      EQUIVALENCE (AGLB(8),FLDISP),(AGLB(9),FLTRNS)
      dimension xryz(5)
      DATA (XRYZ(i),i=1,5)
     +            /2.28962,1.93597,1.54051,0.70926,0.556363/
C
C
C***********************************************************************
C***** If IRESO >< 0 : Resolution function of the instrument is given
C***** Used only with original NPROF=7 (Tomson-Cox-Hasting pseudo-Voigt)
C***** The gaussian and lorentzian FWHM of the instrumental peak is
C***** given as a function of scattering angle
C***********************************************************************
C
      IF(IRESO.NE.0) CALL INSTRES(1,IDUMY,IDUMY,RDUM1,RDUM2,RDUM3)
C
C--------------------------------------------------------- FORMAT(BZ,I8)
      FMTfields = 'i'
      Line_Nb = Line_Nb +1
      Call FindFMT(i_Pcr,aLine,FMTfields,FMTformat,nCarL,iErr)
      if (iErr.eq.-1) GoTo 99999
      if (iErr.ne.0)  GoTo 99995
      READ(aLine,FMTformat) MAXS
C-----------------------------------------------------------------------
      IF(iabs(JOBTYP).GT.1) MAXS=0
      IF(iabs(Icryg).eq.2) MAXS=0
C
C----  CHECK DIMENSIONING FOR SOME EQUIVALENCED ARRAYS
      IF (IDSZ.LT.MSZ*MAXS) THEN
        WRITE(i_Out,180) IDSZ,MSZ,MAXS
      CAll mess(' Problem of dimensions IDSZ < MSZ*MAXS!')
      CALL STOP_COND(' Problem of dimensions (call JRC!) ',1)
      End If
  180 Format(' => Change IDSZ or MSZ so that IDSZ >=MSZ*MAXS'/
     +       ' => IDSZ, Maximum No. of data points = ',I6/
     +       ' => MSZ,  Matrix size                = ',I6/
     +       ' => MAXS, No. of parameters varied   = ',I6/)
C
      WRITE(i_Out,'(a,i5)')
     + ' => Number of Least-Squares parameters varied: ',MAXS
c++++++++++++++++++++++++++++++++++++++++
       if(ICRYG.eq.0) then
c++++++++++++++++++++++++++++++++++++++++
C
C----------------------------------------------------- FORMAT(BZ,10F8.0)
      FMTfields = 'ffffffffi'
      Line_Nb = Line_Nb +1
      Call FindFMT(i_Pcr,aLine,FMTfields,FMTformat,nCarL,iErr)
      if (iErr.eq.-1) GoTo 99999
      if (iErr.ne.0)  GoTo 99995
      READ(aLine,FMTformat)
     +  ZER,FLGZER,DISP,FLDISP,TRANSP,FLTRNS,GLB(26),AGLB(26),IGLMORE
C-----------------------------------------------------------------------
C
        if(ixunit.eq.1) then
         dtt1=disp
         dtt2=transp
         toftet=glb(26)
         aglb(26)=0.0
        endif
      WRITE(i_Out,'(a/a,2F8.2)')
     +  ' => Global parameters and codes ==>',
     +  ' => Zero-point: ',ZER,FLGZER
        if(AGLB(26).gt.0.5.and.glb(26).gt.0.01.and.ixunit.ne.1) then
        lamda(1)=GLB(26)
        lamda(2)=GLB(26)
      WRITE(i_sum,'(a)')' => Wavelength is refined'
      WRITE(i_Out,'(a,F9.6,f8.2)')
     +  ' => Refined Wavelength: ',GLB(26),AGLB(26)
        endif

       if(IGLMORE.NE.0) THEN
C----------------------------------------------------- FORMAT(BZ,10F8.0)
      FMTfields = 'ffffff'
      Line_Nb = Line_Nb +1
      Call FindFMT(i_Pcr,aLine,FMTfields,FMTformat,nCarL,iErr)
      if (iErr.eq.-1) GoTo 99999
      if (iErr.ne.0)  GoTo 99995
      READ(aLine,FMTformat) (GLB(J),AGLB(J),J=27,29)
C-----------------------------------------------------------------------
C
      if(ILOR.eq.0.or.ILOR.eq.3) then
      WRITE(i_sum,'(a)')' => Microabsorption is refined'
      WRITE(i_Out,'(a,3(F8.4,f8.2))')
     +  ' => Microabsorption parameters P0,Cp,Tau: ',
     +      (GLB(J),AGLB(J),J=27,29)
       endif

       ENDIF !IGLMORE
C-----------------------------------------------------------------------
        if(NBCKGD.EQ.2.AND.ISBAC.EQ.-1) then
        FMTfields = 'f'
        Line_Nb = Line_Nb +1
        Call FindFMT(i_Pcr,aLine,FMTfields,FMTformat,nCarL,iErr)
        if (iErr.eq.-1) GoTo 99999
        if (iErr.ne.0)  GoTo 99995
        READ(aLine,FMTformat) Fwindow
      WRITE(i_Out,'(a,F8.2)')
     +  ' => Window for Fourier filtering :', Fwindow
      WRITE(i_Sum,'(a,F8.2)')
     +  ' => Window for Fourier filtering :', Fwindow
        endif
C     ------------------------------------------------ FORMAT(BZ,6G12.6)
      IF(NBCKGD.EQ.0.OR.(NBCKGD.EQ.1.AND.ISBAC.EQ.-1)) THEN
C
C     ------------------------------------------------ FORMAT(BZ,6G12.6)
        FMTfields = 'ffffff'
        Line_Nb = Line_Nb +1
        Call FindFMT(i_Pcr,aLine,FMTfields,FMTformat,nCarL,iErr)
        if (iErr.eq.-1) GoTo 99999
        if (iErr.ne.0)  GoTo 99995
        READ(aLine,FMTformat) BACK
C     ------------------------------------------------ FORMAT(BZ,6G12.6)
        FMTfields = 'ffffff'
        Line_Nb = Line_Nb +1
        Call FindFMT(i_Pcr,aLine,FMTfields,FMTformat,nCarL,iErr)
        if (iErr.eq.-1) GoTo 99999
        if (iErr.ne.0)  GoTo 99995
        READ(aLine,FMTformat) FBACK
C     ------------------------------------------------------------------
        if(NBCKGD.EQ.1.AND.ISBAC.EQ.-1) then

        FMTfields = 'ffffff'
        Line_Nb = Line_Nb +1
        Call FindFMT(i_Pcr,aLine,FMTfields,FMTformat,nCarL,iErr)
        if (iErr.eq.-1) GoTo 99999
        if (iErr.ne.0)  GoTo 99995
        READ(aLine,FMTformat) (GLB(J),J=10,15)
C     ------------------------------------------------ FORMAT(BZ,6G12.6)
        FMTfields = 'ffffff'
        Line_Nb = Line_Nb +1
        Call FindFMT(i_Pcr,aLine,FMTfields,FMTformat,nCarL,iErr)
        if (iErr.eq.-1) GoTo 99999
        if (iErr.ne.0)  GoTo 99995
        READ(aLine,FMTformat) (AGLB(J),J=10,15)
C     ------------------------------------------------ FORMAT(BZ,6G12.6)
        FMTfields = 'ffffff'
        Line_Nb = Line_Nb +1
        Call FindFMT(i_Pcr,aLine,FMTfields,FMTformat,nCarL,iErr)
        if (iErr.eq.-1) GoTo 99999
        if (iErr.ne.0)  GoTo 99995
        READ(aLine,FMTformat) (GLB(J),J=16,21)
        DO J=16,21
         IF(GLB(J).LT.0.00001) GLB(J)=1.0
        END DO
C     ------------------------------------------------ FORMAT(BZ,6G12.6)
        FMTfields = 'ffffff'
        Line_Nb = Line_Nb +1
        Call FindFMT(i_Pcr,aLine,FMTfields,FMTformat,nCarL,iErr)
        if (iErr.eq.-1) GoTo 99999
        if (iErr.ne.0)  GoTo 99995
        READ(aLine,FMTformat) (AGLB(J),J=16,21)
C     ------------------------------------------------------------------
        endif

      End If
c
c  Initializing global parameters 22,23,24,25
c
         do j=22,25
          AGLB(j)=0.0
         end do
         GLB(22)=1.0  !The background is calculated applying the formula
         GLB(23)=0.0  !
         GLB(24)=0.0  ! Back(2q) = GLB(22)*BK[(1+GLB(24))*2q+GLB(25)]+GLB(23)
         GLB(25)=0.0  !
c
c  Reading adjustable background parameters when a background function
c  is read from unit=12.
c  The actual background is calculated with the above formula
c
        if(NBCKGD.EQ.1.AND.ISBAC.EQ.1) then

        FMTfields = 'ffff'
        Line_Nb = Line_Nb +1
        Call FindFMT(i_Pcr,aLine,FMTfields,FMTformat,nCarL,iErr)
        if (iErr.eq.-1) GoTo 99999
        if (iErr.ne.0)  GoTo 99995
        READ(aLine,FMTformat) (GLB(J),J=22,25)
C     ------------------------------------------------
        FMTfields = 'ffff'
        Line_Nb = Line_Nb +1
        Call FindFMT(i_Pcr,aLine,FMTfields,FMTformat,nCarL,iErr)
        if (iErr.eq.-1) GoTo 99999
        if (iErr.ne.0)  GoTo 99995
        READ(aLine,FMTformat) (AGLB(J),J=22,25)
C     ------------------------------------------------
        if(glb(22).lt.1.e-10) glb(22)=1.0
        endif


C
      IF(NBCKGD.EQ.0) WRITE(i_Out,'(a/a,f8.3,a/6G12.6/6F12.2)')
     +  ' => Background parameters and codes ==>',
     +  ' => Origin of polynomial at 2theta: ',BKPOS,' degrees',
     +  BACK,FBACK
      IF(NBCKGD.EQ.1.AND.ISBAC.EQ.-1) THEN
        WRITE(i_Out,'(a//6G12.6,/,6F12.2)')
     +    ' => Background Polynomial parameters and codes ==>',
     +    BACK,FBACK
        WRITE(i_Out,'(a//6G12.6,/,6F12.2)')
     +    ' => Background Bc(i) parameters and codes ==>',
     +    (GLB(J),J=10,15),(AGLB(J),J=10,15)
        WRITE(i_Out,'(a//6G12.6,/,6F12.2)')
     +    ' => Background D(i) parameters and codes ==>',
     +    (GLB(J),J=16,21),(AGLB(J),J=16,21)
      End If
      IF(NBCKGD.EQ.1.AND.ISBAC.EQ.1) THEN
        WRITE(i_Out,'(/a/a/)')
     +    ' => Background read from file and transformed according to:',
     +    '    Back(2q) = a * BackRead[ (1+c)*2q+d ] + b'
        WRITE(i_Out,'(a//10x,4F12.6,/,10x,4F12.2)')
     +    ' => Background coefficients a,b,c,d and codes ==>',
     +    (GLB(J),J=22,25),(AGLB(J),J=22,25)
      End If
      IF(IXUNIT.EQ.1) THEN
      WRITE(i_Out,'(a,2f10.3/a,2f10.3/a,f10.3)')
     +  ' => D-spacing to T.O.F. coefficient 1 and code: ',dtt1,FLDISP,
     +  ' => D-spacing to T.O.F. coefficient 2 and code: ',dtt2,FLTRNS
     + ,' => T.O.F. 2theta average detector angle      : ',toftet
       ELSE
      WRITE(i_Out,'(a,2f8.2/a,2f8.2)')
     +  ' => Displacement peak-shift parameter and code: ',DISP,FLDISP,
     +  ' => Transparency peak-shift parameter and code: ',TRANSP,FLTRNS
      ENDIF
C
      IF(iabs(JOBTYP).GT.1)THEN
        NPTS=(THMAX-THMIN)/STEP+1.5
        ICONSTEP=1
        do i=1,npts
         txv(i)=THMIN+FLOAT(I-1)*STEP
        end do
      else
        call mess(' => Reading intensity file *.DAT...')
        CALL READINT
        if(ICONSTEP.eq.0.and.IPL2.ne.0) IPL2=3
        IF(IWGT.EQ.2) THEN
          DO I=1,NPTS
            VAR(I)=1.0
          End Do
        End If
        IF(ISTEP.gt.1) THEN
      WRITE(i_Out,'(2A,I2)')
     +        ' => The number of data points has been reduced'
     +,                 '    by a factor of ',ISTEP
        ENDIF
      if(ixunit.eq.1) then
      write(i_sum,'(A)')' ==> T.O.F. range, and number of points:'
      write(i_out,'(A)')' ==> T.O.F. range, and number of points:'
      write(i_sum,'(2(a,f10.3)/a,i6)')'    TOFmin: ',thmin,'  TOFmax: ',
     +thmax,'    No. of points: ', NPTS
      write(i_out,'(2(a,f10.3)/a,i6)')'    TOFmin: ',thmin,'  TOFmax: ',
     +thmax,'    No. of points: ', NPTS
        else
      write(i_sum,'(A)')' ==> Angular range, step and number of points:'
      write(i_out,'(A)')' ==> Angular range, step and number of points:'
      write(i_sum,'(3(a,f8.4),a,i6)')'     2Thmin: ',thmin,'  2Thmax: ',
     +thmax,'  Step: ',step,'  No. of points: ', NPTS
      write(i_out,'(3(a,f8.4),a,i6)')'     2Thmin: ',thmin,'  2Thmax: ',
     +thmax,'  Step: ',step,'  No. of points: ', NPTS
        endif
      End If
C
      IF (NPTS.GT.IDSZ) THEN
        WRITE(i_Out,190) IDSZ,NPTS
      call mess(' Too many data points NPTS>IDSZ!')
      CALL STOP_COND(' Too many data points ',1)
      End If
  190 Format(' => Program can handle only',I5,' points',/,
     +       3X,I5,' points were input')

C
C
C***********************************************************************
C*****  BACKGROUND CALCULATED FROM POLYNOMIAL FUNCTION
C***********************************************************************
C
C----- Background : polynomial
C
      IF (NBCKGD.lt.1.OR.(NBCKGD.EQ.1.AND.ISBAC.EQ.-1) ) THEN
        DO I=1,NPTS
          TH=Txv(i)
          THX=TH/BKPOS-1.
          BK(I)=BACK(1)
          DO J=2,6
            BK(I)=BK(I)+BACK(J)*THX**(J-1)
          End Do
        End Do
C
C----- Background : Debye-Like function of six terms
C
        IF(ISBAC.EQ.-1) THEN
          DO I=1,NPTS
          TH=Txv(i)
          QVAL=12.56637061*SIN(TH/114.59155902)/LAMDA(1)
          if(qval.gt.0.0) then
            DO J=1,6
             AUXX=QVAL*GLB(J+15)
             BK(I)=BK(I)+GLB(J+9)*SIN(AUXX)/AUXX
            END DO
          endif
          END DO
        ENDIF
C
C----- Background read from file
C
      Else IF (read_bac) Then
        Call Openfile(12,0,1)
        READ(i_bac,'(a)',END=99997) aLine
        READ(i_bac,*,END=99997)(BK(I),I=1,NPTS)
        Close(unit=i_bac)
C
C----- Background : Linear interpolation
C
      Else IF(ISBAC.ne.-1) Then      ! NBCKGD.ge.1
C
        NBX=1
        NBAC1=NBCKGD
        DIFL=POS(1)-THMIN
        DIFR=POS(NBCKGD)-THMAX
C
        IF(DIFL.ge.0) Then
          if(iconstep.eq.1) then
           NBX=DIFL/STEP+1.5
          else
           call locate(npts,txv,pos(1),nbx)
          endif
          DO I=1,NBX
            BK(I)=BCK(1)
          End Do
        End If
C
        IF(DIFR.le.0) Then
          NBAC1=NBCKGD+1
          POS(NBAC1)=THMAX
          BCK(NBAC1)=BCK(NBCKGD)
        End If
C
        NXX=2
        DO 200 I=NBX,NPTS
          THET=txv(i)
          DO J=NXX,NBAC1
            DELT=POS(J)-THET
            IF(DELT.GT.0.) Then
              SLOPE=(BCK(J)-BCK(J-1))/(POS(J)-POS(J-1))
              BSTEP=(THET-POS(J-1))*SLOPE
              BK(I)=BCK(J-1)+BSTEP
              NXX=J-1
              Goto 200
            End If
          End Do
  200   Continue      ! Do I=NbX,nPts
        BK(NPTS)=BK(NPTS-1)
C
C----- BACKGROUND : Interpolation by Cubic splines (NBCKGD>2 ISBAC=-1)
      Else if(NBCKGD.gt.2) then
        NB1=1
        IF(THMIN.LT.POS(1)) THEN
          if(iconstep.eq.1) then
           NB1=(POS(1)-THMIN)/STEP+1.5
          else
           call locate(npts,txv,pos(1),nb1)
          endif
          DO KK=1,NB1
            BK(KK)=BCK(1)
          End Do
        End If
        NBAC1=NBCKGD
        IF(POS(NBCKGD).lt.THMAX) THEN
          POS(NBCKGD+1)=THMAX
          BCK(NBCKGD+1)=BCK(NBCKGD)
          NBAC1=NBCKGD+1
        End If
C
C       -- Evaluate 1rst derivatives at point1 and  NBCKGD+1
c       DIFB=POS(2)-POS(1)
c       IF(ABS(DIFB).LT.3*STEP) THEN
c         YP1=0.0
c       Else                            !Fixed derivatives
c         YP1=(BCK(2)-BCK(1))/DIFB      !selected below...if behaves better!
c       End If
c       YPN=0.0
         yp1=9.9e+32
         ypn=9.9e+32
        CALL SPLINE(POS,BCK,NBAC1,YP1,YPN,Y2D)
C
C       -- Start calculation of background point by point
        DO I=NB1,NPTS
          XT=Txv(i)
          CALL SPLINT(POS,BCK,Y2D,NBAC1,XT,BBAC)
          BK(I)=BBAC
        End Do
C
      End If            ! IF (NBCKGD...) Then
c++++++++++++++++++++++++++++++++++++++++
       endif    !if(ICRYG.eq.0) then
c++++++++++++++++++++++++++++++++++++++++
C
      if(jobtyp.eq.0.or.jobtyp.eq.2) then
         DO IX=1,5
          IF(LAMDA(1)+0.1.GT.XRYZ(IX)) GOTO 130
         End Do
  130 IXRAYG=IX
      endif
C
C***********************************************************************
C***** READ PARAMETERS PHASE by PHASE
C***********************************************************************
C
      SLCONS=.FALSE.
      DO K=1,NPHASE
        IC(K)=0
      End Do
        icry=0
C
      DO K=1,NPHASE
C
      call message(' Reading parameters for phase:',K,0.0,1)
C
      iform_fac(K)=0
      Call Read_PhasesCond(K,N)
      Call Read_PhasesAtom(K,N,iof)
      Call Read_PhasesProf(K)
      Call Apply_Helixcons(K,N,iof)
      Call Print_CodesProf(K)
      Call Read_Constrain(K)
C------------------------------------------------------------
        U(1)=PAR(K,3)
        VV(1)=PAR(K,4)
        W(1)=PAR(K,5)
        if(iuvw.eq.1) then
         U(2)=PAR(K,43)
         VV(2)=PAR(K,44)
         W(2)=PAR(K,45)
        else
         U(2)=PAR(K,3)
         VV(2)=PAR(K,4)
         W(2)=PAR(K,5)
        endif
        IF (NPRO(K).EQ.8) THEN
          ULOR=PAR(K,15)
          VLOR=PAR(K,16)
        End If
C
C phase ****************************************************************
C phase *** SWITCH TO GENERATION OR READING THE BRAGG REFLECTIONS
C phase ****************************************************************
C
        IF(IRF(K).eq.0.or.irf(k).eq.-1) THEN
          IMU=2
          IF(NSPGRP.EQ.3)IMU=1
          IF(NSPGRP.GT.5.AND.NSPGRP.LT.10)IMU=1
          IF(NSPGRP.EQ.11.OR.NSPGRP.EQ.12)IMU=1
          call mess(' => Generating reflections ')
          CALL REFGEN(K,ZER,DISP,TRANSP,PAR(K,12))
        ElseIF(iabs(IRF(K)).eq.3.or.iabs(irf(k)).eq.2) THEN
          call mess(' => Reading reflections ')
          CALL REFLEC(K,ZER,DISP,TRANSP)
        ElseIF(IRF(K).eq.1) THEN
          call mess(' => Reading reflections ')
          CALL REFLEC(K,ZER,DISP,TRANSP)
        ELSEIF(iabs(IRF(K)).eq.4) THEN
          IMU=2
          IF(NSPGRP.EQ.3)IMU=1
          IF(NSPGRP.GT.5.AND.NSPGRP.LT.10)IMU=1
          IF(NSPGRP.EQ.11.OR.NSPGRP.EQ.12)IMU=1
          CALL INTEG_HKL(K)
        ELSE
          CALL STOP_COND(' Illegal IRF value ',1)
        End If
C------------------------------------------------------------
C   Look for scattering factors of atoms of phase K
C------------------------------------------------------------
C
      job=iabs(Jtyp(k))
      IF((JOB.EQ.0.OR.JOB.EQ.2).AND.iabs(IRF(K)).eq.4) THEN
         DO IX=1,5
          IF(R_LAMBDA(k)+0.1.GT.XRYZ(IX)) GOTO 131
         End Do
  131    IXRAY=IX
      else
         IXRAY=IXRAYG
      ENDIF
        IF(.not.(iabs(JBT(K)).EQ.2 .or.iabs(JBT(K)).EQ.3)) Then
          CALL LOOKUP(K,NATOM(K),NSC,IXRAY,JOB)
        End If
C------------------------------------------------------------
C
        ICY=1
        ICZ=0
        DO IIPHAS=1,K
          ICZ = ICZ + IC(IIPHAS)
        End Do
        IF (K.GE.2) ICY=1+ICZ-IC(K)
        IF (LST1.NE.1) GOTO 320
        IXDEL=0
C
        DO 310 IXX=ICY,ICZ
          IX=IXX-IXDEL
C*I
          IVK=IHKL(IXX)
C*F
          IRL=MOD(IREFS(IXX),256)-128
          IRK=MOD(IREFS(IXX)/256,256)-128
          IRH=MOD(IREFS(IXX)/256/256,256)-128
          IRC=MOD(IREFS(IXX)/256/256/256,8)
C*IF
          IF (NPRO(K).EQ.8) THEN
            IF(NVK(K).EQ.0) THEN
              IF(MOD(IX-1,60).EQ.0)  WRITE(i_Out,'(a/)')
     +          '1No.  Code    H   K   L   Mult      Hw    '//
     + '2theta/TOF       L-factor       HWL       HWG     ETA '
              WRITE(i_Out,'(1X,2I4,3X,3I4,I6,2F12.3,F14.4,3F8.3)')
     +          IX,IRC,IRH,IRK,IRL,MLT(IXX),(REFS(IXX,JX),JX=1,3),
     +          HALFL(IXX), HALFG(IXX),GAM(IXX)
            Else
              IF(MOD(IX-1,60).EQ.0) WRITE(i_Out,'(a/)')
     +          '1No.  Code    H   K   L  IVK    Mult     Hw     '//
     +     '2theta/TOF       L-factor       HwL       HwG     ETA '
              WRITE(i_Out,'(1X,2I4,3X,3I4,I5,I6,2F12.3,F14.4,3F8.3)')
     +          IX,IRC,IRH,IRK,IRL,IVK,MLT(IXX),(REFS(IXX,L),L=1,3),
     +          HALFL(IXX), HALFG(IXX),GAM(IXX)
            End If
            GO TO 310
          END IF  !         IF (NPRO(K).EQ.8) THEN
C*IF
          IF(NVK(K).EQ.0) THEN
            IF(MOD(IX-1,60).EQ.0) WRITE(i_Out,'(a/)')
     +     '1No.  Code    H   K   L   Mult       Hw     '//
     +     '2theta/TOF       L-factor'
            WRITE(i_Out,'(1X,2I4,3X,3I4,I6,2F12.3,F14.4)')
     +        IX,IRC,IRH,IRK,IRL,MLT(IXX),(REFS(IXX,JX),JX=1,3)
          Else
             IF(MOD(IX-1,60).EQ.0) WRITE(i_Out,'(a/)')
     +         '(1No.  Code    H   K   L  IVK    Mult      Hw     '//
     +         ' 2theta/TOF       L-factor'
             WRITE(i_Out,'(1X,2I4,3X,3I4,I6,I5,2F12.3,F14.4)')
     +         IX,IRC,IRH,IRK,IRL,IVK,MLT(IXX),(REFS(IXX,L),L=1,3)
          End If
  310   CONTINUE      ! DO 310 IXX=ICY,ICZ
  320   Continue      ! IF (LST1.NE.1)
C
        DO IX=ICY,ICZ
          REFS(IX,3)=REFS(IX,3)*FLOAT(MLT(IX))
        END DO
C
      END DO             ! DO K=1,NPHASE   #### End of Phase ###
C
C
C***********************************************************************
C***** ALL PHASES HAVE BEEN READ
C***********************************************************************

      CLOSE(UNIT=i_Sym)
C
      DO I=1,NGL
        X=AGLB(I)
        IYY=INT(ABS(X)/10.)
        LGLB(I)=IYY
        AGLB(I)=(ABS(X)-10.*FLOAT(IYY))*SIGN(1.,X)
      End Do
C
C  Reading NRELL limits of parameters (numpar, lim1, lim2)
C
      if(NRELL.ne.0) then
        do i=1,MAXS
         numpar(i)=0
         vlim1(i)=0.0
         vlim2(i)=0.0
        end do
        write(i_Out,'(/a/)')
     +      ' => The following parameter limits have been read:'
        do i=1,NRELL
          FMTfields = 'iff'
          Line_Nb = Line_Nb +1
          Call FindFMT(i_Pcr,aLine,FMTfields,FMTformat,nCarL,iErr)
          if (iErr.eq.-1) GoTo 99999
          if (iErr.ne.0)  GoTo 99995
          READ(aLine,FMTformat) ILI(I),VLIM1(ILI(I)),VLIM2(ILI(I))
          write(i_Out,'(a,i4,a,2f10.4)')'  -> Parameter no.: ',ili(i),
     +      ' Limits: ',VLIM1(ILI(I)),VLIM2(ILI(I))
          NUMPAR(ILI(I))=1
        end do
      endif
      if(icryg.eq.2) then
          FMTfields = 'iiii'
          Line_Nb = Line_Nb +1
          Call FindFMT(i_Pcr,aLine,FMTfields,FMTformat,nCarL,iErr)
          if (iErr.eq.-1) GoTo 99999
          if (iErr.ne.0)  GoTo 99995
          READ(aLine,FMTformat) Nconfg,nsolu,NSELR,nscalef
          write(i_Out,'(/a,i7,a,i4,a)')'  => A number of ',nconfg,
     +' random configurations will be tested on ',NSELR,' observations'
          write(i_Out,'(a,i3, a)')'     The best ',nsolu,
     +    ' solutions will be printed'
          if(nscalef.ne.0) then
              write(i_Out,'(a)')
     +    '     The scale factor will be calculated automatically'
          endif
      endif
      call mess(' => End of preliminary calculations !')
      ioff=0
      ini=0
      CALL GGTIM(ioff,ini)
      IF (iabs(JOBTYP).GT.1) RETURN

      if(icryg.ne.2) then    ! Check matrix only if L.S. job not for MONTE
C
C-----  CHECK FOR HOLES IN THE NORMAL MATRIX
      ISTOP=0
      NATOMS = 0
      DO K=1,NPHASE
        NATOMS = NATOMS + NATOM(K)
        npari(k)=0
      End Do
C
      DO 330 I=1,MAXS
C
        DO J =1,NGL
          IF (I.EQ.LGLB(J)) GO TO 330
        End Do
C
        DO K=1,NPHASE
          DO J=1,MPAR
            IF(I.EQ.LPAR(K,J)) GO TO 330
          End Do
        End Do
C
           ipiof=1
        DO K=1,NPHASE
           do L=ipiof,ipiof+NATOM(k)-1
          DO J=1,nat_p
            IF(I.EQ.LP(L,J)) then
               npari(k)=npari(k)+1
               GO TO 330
            endif
          End Do
           End Do
           ipiof=ipiof+NATOM(k)
        End Do
C*I
        DO K=1,NPHASE
          DO L=1,NVK(K)
            DO J=1,3
              IF(I.EQ.LVK(K,L,J)) GO TO 330
            End Do
          End Do
        End Do
C*F
        call message(' => Hole in the matrix!, missing element:',i,0.,1)
        WRITE(i_Out,'(a,i3,a)')
     +    ' => Hole in the matrix!, element ',I,
     +  'in the Normal matrix is missing'
          ISTOP = 1
  330 CONTINUE      ! DO 330 I=1,MAXS
C
C----- END CHECKING
      IF (ISTOP.EQ.1) CALL STOP_COND(' Hole(s) in the Normal Matrix ',1)
C
C----- CHECK FOR NON-ZERO COUNTS AT ALL POINTS
      DO I=1,NPTS
        IF (VAR(I).LE.1.0E-6) THEN
          ANGLEP = Txv(i)
          WRITE(i_Out,'(a,i7,a,F8.4)')
     +      ' => Zero counts at step no.',I,' at 2theta ',ANGLEP
      call message(' Zero counts al point no. ',I,0.,1)
      call mess(' Program fix intensity at 1.0 and Variance at 1E6')
c      CALL STOP_COND(' Zero counts at some point ',1)
      y(i)=1.0
      VAR(i)=1.E6
        End If
      End Do

      endif !Icryg.ne.2    Check matrix only if L.S. job
c
c  Check that number of generated and observed reflections verifies
c  IDSZ-IRS gt NPTS
c
      ICC=0
      do k=1,nphase
       ICC=ICC+NOBS(k)
      end do
      if(IDSZ-(ICZ+ICC).le.NPTS) then
        CALL STOP_COND(' Too many reflections or too many points! ',1)
      endif
      RETURN
99999 CALL STOP_COND(' End of file *.PCR ',1)
99997 CALL STOP_COND(' End of file *.BAC ',1)
99995 Call FindFMT_Err(iErr,aLine,nCarL)
      Call message(' Please check your *.PCR file at line: ',Line_Nb,
     + 0.0,1)
      CALL STOP_COND(' Format error ',1)
      end
