C    Dimensions can be adapted to the available memory by changing
C    the values in PARAMETER statements
C
C     IDSZ:     Maximum number of points in the diffraction pattern(s)
C               if there is no additional integrated intensities as
C               observations.
C     IRS:      Maximum number of reflections
C     NATS:     Maximum number of atoms in asymmetric unit (all phases included)
C     MSZ:      Maximum number of refinable parameters
C     NOV:      Maximum number of overlapping reflections
C     NMAGM:    Maximum number of rotation-matrices sets for magnetic structure
C     NATM:     Maximum number of magnetic atoms (NATM+nonmag-atoms <=NATS)
C     NEQV:     Maximum number of user-supplied symmetry operators/
C                                                    /propagation vectors
C
C       (constraint: IDSZ >= MSZ*MSZ)
C       (constraint: IDSZ >= 4*IRS  )
C       (constraint: IDSZ-IRS> effective number of points in diff.patterns)
C
C
C     IEXCL:    Maximum number of excluded regions
C     IBACP:    Maximum number of background points
C     NPHT:     Maximum number of phases (<=8)
C     NAT_P:    Maximum number of atomic parameters per atom
C     MPAR:     Maximum number of non atomic parameters for each phase
C     NGL :     Maximum number of global parameters
C     NCONST:   Maximum number of slack constraints per phase
c     N_spe:    Maximun number of different chemical species
c     N_form:   Maximum number of scattering factor values in a table
c     NPR:      Maximum number of points defining a numerical profile
c     INPR:     Maximum number of different numerical peak shapes
c     NPRC:     Maximum number of terms in the table for correcting
c               intensities
C
      Integer*4
     + IDSZ,IRS,NATS,MPAR,MSZ,NOV,IEXCL,IBACP,NPHT,NMAGM,NATM,NEQV,NGL,
     +   i_Dat,  i_Sym,  i_Rpa,  i_Pcr,  i_Out,  i_Sum,  i_hkl,
     +   i_Fou,  i_Ghkl, i_Sav, i_Shkl, i_Prf, i_Bac, i_Res, i_Sim,
     +   i_Sch,  i_New,  i_Shx, i_Atm, i_Sub
C
C     Usual Parameters for PC, 4Mbytes core memory
c
c     PARAMETER (IDSZ=8600,IRS=2600,NATS=100,MPAR=90,MSZ=90,NOV=256)
c     PARAMETER (IEXCL=30,IBACP=100,NPHT=6,NMAGM=6,NATM=46,NEQV=24)
c     PARAMETER (NAT_P=20,NGL=40,NCONST=16,N_spe=8,N_form=60,NPR=150)
c     PARAMETER (INPR=4,NPRC=100)
c
c
C     Usual Parameters for PC, 8Mbytes core memory
C
      PARAMETER(IDSZ=24000,IRS=5300,NATS=230,MPAR=90,MSZ=150,NOV=990)
      PARAMETER(IEXCL=30,IBACP=100,NPHT=8,NMAGM=8,NATM=56,NEQV=48)
      PARAMETER(NAT_P=25,NGL=40,NCONST=50,N_spe=16,N_form=60,NPR=150)
      PARAMETER(INPR=4,NPRC=100)
C
C  Logical units used in the program
C
      Parameter
     +  (i_Pcr=1,i_Rpa=2,i_Sym=3,i_Dat=4,i_Out=7,i_Sum=8)
      Parameter
     +  (i_Fou=9,i_Ghkl=10,i_Sav=11,i_Bac=12,i_Res=13,i_Sim=14)
      Parameter
     +  (i_hkl=15,i_Shkl=16,i_Prf=17,i_Sch=18,i_New=19,i_Shx=21)
      Parameter
     +  (i_Atm=22,i_Sub=23,i_shp=24,i_cor=25)
c
c   String with date and time
c
      character DAT_TIM*40
      common/date_and_time/dat_tim
