      SUBROUTINE STRMOD(NN,IX,IPH,IRL,N,IOF,ICENT,HNN,SSNN,FNN,TAV,DERI)
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c     General rigid-body-constraints subroutine for Rietveld refinement
c               with TLS refinements (for all Space Groups)
c                       for rbg including satellites
c
c                    Revisited version for any OS/machine (?)
c
c                 Dr. Vincent Rodriguez
c                 Laboratoire de Spectroscopie Moleculaire et Cristalline *
c                 URA 124 CNRS
c                 Universite de Bordeaux I, 351 cours de la liberation
c                 33405 TALENCE Cedex France
c                 Phone: (++ 33) (0) 5 56 84 63 61
c                 Fax:   (++ 33) (0) 5 56 84 84 02
c                 e-mail vincent@loriot.lsmc.u-bordeaux.fr
c                 http://loriot.lsmc.u-bordeaux.fr
c
c                 * UMR Physico-Chimie Moleculaire since January 1st 1997
c                          ====================
c
c                         Version 1.4 - January 1997
c
c       as v1.1 but with
c        - corrected molview file : atomic coordinates for
c          all atoms in the crystallographic cell.
c        - introduction of the S combination in TLS option -> for all SG
c          calculation of the center of mass for the whole concerned rbg
c          in the TLS model
c          As S11+S22+S33=0, we set S33=-S11-S22
c          xl(iat1,6)=iopt=5,0n  : pour option TLS
c               n=0 -> centre de masse assimile a l'origine cog(i,igr)
c                      cas spg centrosymmetrique par exemple
c               n=1 -> centre de masse pris comme origine des calculs TLS
c                      obligatoire en cas de systemes non centrosymetriques
c               Il est recommande de faire coincider le centre de masse et
c               l'origine du groupe pour avoir un calcul TLS correct !!!
c               Dans ce dernier cas, il faut donc generer la molecule entiere
c               pour que le centre de masse soit juste.
c       -  new names for some variables
c       -  option for free atoms :
c               if xl(iat,15)=1. => Uij are transformed in Betaij
c               (therefore xl(iat,15) is reset to zero)
c       - standard EULER angle notation has been adopted
c       - number of parameters set to 16 (instead of 15) : chi(ng)= P16
c         --> P6 and P15 define now the different options
c-----------------------------------------------------------------------
c----general parameters from main program
      INCLUDE 'ful0.inc'
      INCLUDE 'ful1.inc'
      INCLUDE 'ful2.inc'
      DIMENSION  DERI(MSZ),XI(14),SNX(NATS),SA(NATS),SB(NATS),
     *           TEMP(NATS),SNEX(NATS),T(3),SUMAX(NATS,9),
     *           SUMBX(NATS,9),SM(3,3),
     *           HNN(3),H(3)
      Integer  Mod6
      common/SymOpda/Mod6(36,3,3)
C----------------------------------------------------------------------------
c----rigid-body-constraints/TLS parameters
      PARAMETER (NGPMAX=10,MAXATOME=100)
      CHARACTER info_rbg_tls*60,REC(maxatome)*2,TOBJ(ngpmax)*2
      common/inforbg/info_rbg_tls
      common/char_rbg/rec,tobj

      common/rbg_int/igr_off,ng,mpardeb,irbglabel,MYCYCLE,NUM(MAXATOME),
     * IOPT(NGPMAX),ISAT(NGPMAX,2),IGEN(NGPMAX),IGR(NGPMAX),
     * NGMAX(NPHT),IRIGID(NPHT),itls(ngpmax),ipg(ngpmax)

      common/rbg/X0(MAXATOME),Y0(MAXATOME),Z0(MAXATOME),
     *           DIST(MAXATOME),ALPHA(MAXATOME),RZ(MAXATOME),
     *           XTH(NGPMAX),XPH(NGPMAX),CHI(NGPMAX),
     *           XA(3,3,NGPMAX),XAP(3,3,NGPMAX),FMAT(3,3,NPHT),
     *           COG(3,NGPMAX),CMAT(3,3,NPHT),CTMAT(3,3,NPHT),
     *           COSAT1(NGPMAX,3),COSAT2(NGPMAX,3),rbgt(6,ngpmax),
     *           rbgl(6,ngpmax),sumatl(maxatome,21),sumbtl(maxatome,21),
     *           xog(3,ngpmax),tspg(4,3),rbgs(9,ngpmax),xcm(3,ngpmax),
     *           xmass(ngpmax), ad(3,npht),bd(3,npht)
      logical ort_bs_m
      common/plots_struct/ort_bs_m
C----------------------------------------------------------------------------C
      common/more_var/XDPAR(3,NGPMAX), DX0(MAXATOME),DY0(MAXATOME),
     *                DZ0(MAXATOME)
      dimension QQ(3,3),OTI(3,3),TOTI(3,3),beta(3,3),dt(21)
      dimension dv0(6,3),bij(3,3),DX(3)
C----------------------------------------------------------------------------C
      IF(ICYCLE_C.NE.MYCYCLE) THEN
        DO I=1,NPHASE
          IRIGID(I)=0
        END DO
        MYCYCLE=ICYCLE_C
      END IF
      IF(IRIGID(IPH).ne.1) then
       PI=ACOS(-1.)
       Call First(IPH,N,IOF)
      endif
      NX=0
      DO 4310 IIPHAS=1,NPHASE
4310  NX=NX+NATOM(IIPHAS)
      DO I=1,NX
        DO J=1,9
          SUMBX(I,J)=0.
          SUMAX(I,J)=0.
          sumatl(i,j)=0.
          sumbtl(i,j)=0.
        end do
        do j=10,21
          sumatl(i,j)=0.
          sumbtl(i,j)=0.
        end do
      end do

      DO I=1,3
        DO J=1,3
         OTI(I,J) = CMAT(I,J,IPH)
         TOTI(I,J)=CTMAT(I,J,IPH)
        END DO
      END DO
      CV=0.
      DV=0.
      AV=0.
      BV=0.
C
C-----CALCULATION OF COS(H.X),SIN(H.X) AND TEMP. FACTOR FOR EACH ATOM
C-----FOR THE STANDARD MODEL OF NUCLEAR STRUCTURE FACTORS
C
C
C  LOOP OVER N ATOMS OF PHASE IPH
C
      ig=igr_off
c-----------------------------------------------------------------
      DO 8 I=1,N       !Loop over atoms (FNN calc)  IF-Blocks are numbered!
c-----------------------------------------------------------------
      SNXI=0.
      SAI=0.
      SBI=0.
      IPIOF=I+IOF
      DO J=1,14
        XI(J)=0.
      END DO
      IF(NUM(IPIOF).EQ.0) THEN                 !---1
c------free atom
        JEND=14
       ELSE                                    !
c-------RBG option
        if(num(ipiof).eq.1) ig=ig+1
        JEND=5
      END IF                                   !---1
      DO 9 J=1,JEND
        XI(J)=XL(IPIOF,J)
9     CONTINUE
C
C  LOOP OVER SYMMETRY OPERATORS
C  SET INDICES FOR APPLYING SELECTED SYMMETRY OPERATORS
C  IDENTITY IS ALWAYS APPLIED AND MUST BE THE FIRST SYM.OP.
C
      IRIN=ISAP(IPIOF,1)
      IRFI=ISAP(IPIOF,2)
      IF(IRIN.EQ.0.OR.IRFI.EQ.0) THEN          !---2
        IRIN=1
        IRFI=IRL
      ENDIF                                    !---2
      IR=0
  313 DO 10 IRR=IRIN,IRFI
  317 IF(IRIN.NE.1.AND.IR.EQ.0) THEN           !---3
        IR=1
       ELSE
        IR=IRR
      ENDIF                                    !---3
      II=IABS(IVEC(IPH,IR))
      ISS=IVEC(IPH,IR)/II
      DO J=1,3
       T(J)=TR(IPH,IR,J)
       DO L=1,3
        SM(J,L)=ISS*MOD6(II,J,L)
       end do
      end do
C
      X=0.
      DO 6 II=1,3
      YY=0.
      X=T(II)*HNN(II)+X
      DO 7 J=1,3
    7 YY=SM(J,II)*HNN(J)+YY
    6 H(II)=YY
      ARG=X
      DO 11 J=1,3
   11 ARG=H(J)*XI(J)+ARG
      ARG=2.*pi*ARG
      arg2=0.
      arg3=0.
c-------------------------------------------------
      IF(NUM(IPIOF).EQ.0) THEN                 !---4Free atoms
c-------------------------------------------------
c------Betaij for free atoms in cell coordinates
        ARG2=H(1)*H(1)*XI(9)+H(2)*H(2)*XI(10)+H(3)*H(3)*XI(11)
     *       +2.*H(1)*H(2)*XI(12)+2.*H(1)*H(3)*XI(13)
     *       +2.*H(2)*H(3)*XI(14)
c--------------------------------------------------------------------------
c--------writes the atomic temperature factors in output file "filenam.ort"
c--------------------------------------------------------------------------
        IF(.not.ort_bs_m) THEN                                !---5
          write(39+iph,'(a,a2,i2,3f8.5,/,a,a2,i2,1X,6f8.5)')
     *     'ATOM      ',NTYP(I+IOF),I,(xl(I+IOF,kk),kk=1,3),
     *     'BETA      ',NTYP(I+IOF),I,(xl(I+IOF,kk),kk=9,14)
c          if(i.eq.n) close(unit=39+iph)
        END IF                                                !---5
       else !---of IF-4 Free atoms
c-------------------------------------------------------------------
        if(abs(iopt(ig)).eq.5.or.
     *     (abs(iopt(ig)).eq.2.and.abs(iopt(igr(ig))).eq.5)) then !---7TLS
c-------------------------------------------------------------------
c--------TLS calculations in all systems
c--------cartesian coordinates of the atom in the rbg referred
c--------to the centre of mass
          jg=ig
          xt=x0(ipiof)
          yt=y0(ipiof)
          zt=z0(ipiof)
c--------same for satellite rbg
          if(abs(iopt(ig)).eq.2.and.abs(iopt(igr(ig))).eq.5) then !---8
            xt=xt+x0(ISAT(IG,1))
            yt=yt+y0(ISAT(IG,1))
            zt=zt+z0(ISAT(IG,1))
            jg=igr(ig)
          end if                                                  !---8
          xt=xt+xcm(1,jg)
          yt=yt+xcm(2,jg)
          zt=zt+xcm(3,jg)
c--------T L calculations for each atom --> arg3
c--------B matrix in orthogonal reference (mean square displacements)
          bij(1,1)=rbgt(1,jg)+yt*yt*rbgl(3,jg)-2.*yt*zt*rbgl(6,jg)
     *           +zt*zt*rbgl(2,jg)
     *           +2.*(zt*rbgs(7,jg)-yt*rbgs(8,jg))
          bij(2,2)=rbgt(2,jg)+xt*xt*rbgl(3,jg)-2.*xt*zt*rbgl(5,jg)
     *           +zt*zt*rbgl(1,jg)
     *           +2.*(xt*rbgs(9,jg)-zt*rbgs(4,jg))
          bij(3,3)=rbgt(3,jg)+xt*xt*rbgl(2,jg)-2.*xt*yt*rbgl(4,jg)
     *           +yt*yt*rbgl(1,jg)
     *           +2.*(yt*rbgs(5,jg)-xt*rbgs(6,jg))
          bij(1,2)=rbgt(4,jg)-xt*yt*rbgl(3,jg)+xt*zt*rbgl(6,jg)
     *           +yt*zt*rbgl(5,jg)-zt*zt*rbgl(4,jg)
     *           +zt*(rbgs(2,jg)-rbgs(1,jg))+xt*rbgs(8,jg)-yt*rbgs(9,jg)
          bij(1,3)=rbgt(5,jg)+xt*yt*rbgl(6,jg)-xt*zt*rbgl(2,jg)
     *           +yt*zt*rbgl(4,jg)-yt*yt*rbgl(5,jg)
     *           +yt*(rbgs(1,jg)-rbgs(3,jg))+zt*rbgs(6,jg)-xt*rbgs(7,jg)
          bij(2,3)=rbgt(6,jg)-xt*xt*rbgl(6,jg)+xt*yt*rbgl(5,jg)
     *           +xt*zt*rbgl(4,jg)-yt*zt*rbgl(1,jg)
     *           +xt*(rbgs(3,jg)-rbgs(2,jg))+yt*rbgs(4,jg)-zt*rbgs(5,jg)
          bij(2,1)=bij(1,2)
          bij(3,1)=bij(1,3)
          bij(3,2)=bij(2,3)
c--------Beta = 2*pi^2*Ct*B*C (Ct = transpose of C)
          call matmult(bij,oti,qq,3)
          call matmult(toti,qq,beta,3)
c--------T(h)=exp(-ht*beta*h) { h(h,k,l), ht = transpose of h}
          do ii=1,3
            do jj=1,3
              arg3=arg3+h(ii)*h(jj)*beta(ii,jj)
            end do
          end do
          arg3=2.*pi*pi*arg3
c--------writes the atomic temperature factors in output file "ortep.out"
        IF(.not.ort_bs_m) THEN                               !---5bis
            write(39+iph,'(a,a2,i2,3f8.5,/,a,a2,i2,1X,6f8.5)')
     *       'ATOM      ',NTYP(I+IOF),I,(xl(I+IOF,kk),kk=1,3),
     *       'BETA      ',NTYP(I+IOF),I,(beta(kk,kk)*2.*pi*pi,kk=1,3),
     *       beta(1,2)*2.*pi*pi,beta(1,3)*2.*pi*pi,beta(2,3)*2.*pi*pi
c          if(i.eq.n) close(unit=39+iph)
        END IF                                                !---5bis
       END IF                                                 !---7TLS
       end if                                                 !---4Free atoms
c--------------------------------------------------------all IF-blocks closed
      EXPARG=EXP(-ARG2-arg3)
      COSA=COS(ARG)*EXPARG
      SINA=SIN(ARG)*EXPARG
      SAI=SAI+COSA
      IF(ICENT.EQ.1) SBI=SINA+SBI
      DO 14 JJ=1,3
      SUMAX(I,JJ)=SUMAX(I,JJ)+H(JJ)*SINA
  14  IF(ICENT.EQ.1)SUMBX(I,JJ)=SUMBX(I,JJ)+H(JJ)*COSA
      if(num(ipiof).eq.0) then                       !---9Free atoms
c------free atom
        SUMAX(I,4)=SUMAX(I,4)+H(1)*H(1)*COSA
        SUMAX(I,5)=SUMAX(I,5)+H(2)*H(2)*COSA
        SUMAX(I,6)=SUMAX(I,6)+H(3)*H(3)*COSA
        SUMAX(I,7)=SUMAX(I,7)+H(1)*H(2)*COSA
        SUMAX(I,8)=SUMAX(I,8)+H(1)*H(3)*COSA
        SUMAX(I,9)=SUMAX(I,9)+H(2)*H(3)*COSA
        IF(ICENT.EQ.1) THEN                            !---10
          SUMBX(I,4)=SUMBX(I,4)+H(1)*H(1)*SINA
          SUMBX(I,5)=SUMBX(I,5)+H(2)*H(2)*SINA
          SUMBX(I,6)=SUMBX(I,6)+H(3)*H(3)*SINA
          SUMBX(I,7)=SUMBX(I,7)+H(1)*H(2)*SINA
          SUMBX(I,8)=SUMBX(I,8)+H(1)*H(3)*SINA
          SUMBX(I,9)=SUMBX(I,9)+H(2)*H(3)*SINA
        END IF                                         !---10
       else  ! from 9Free atoms
c--------------------------------------------------------------
        if(abs(iopt(ig)).eq.5.or.                                !--11TLS
     *     (abs(iopt(ig)).eq.2.and.abs(iopt(igr(ig))).eq.5)) then
c--------------------------------------------------------------
c--------derivatives of the TLS components
          call get_tls_derivatives(h,CMAT,xt,yt,zt,dt)
c--------T: 1 to 6 / L: 7 to 12 / S: 13 to 21
          do kk=1,21
            sumatl(i,kk)=sumatl(i,kk)+cosa*dt(kk)
          end do
          if(icent.eq.1) then                     !-----12
c----------derivatives of the TLS components
c----------T: 1 to 6 / L: 7 to 12 / S: 13 to 21
            do kk=1,21
             sumbtl(i,kk)=sumbtl(i,kk)+sina*dt(kk)
            end do
          end if                                  !-----12
        end if                                    !---11TLS
      end if                                      !---9Free atoms
c--------------------------------------------------------all IF-blocks closed
C
C  THE FOLLOWING IS FOR ASSURE THE APPLICATION OF THE IDENTITY SYMM.OP.
C
      IF(IRIN.NE.1.AND.IR.EQ.1) THEN              !---13
        IR=IRIN
        GOTO 317
      ENDIF                                       !---13
C
   10 CONTINUE
C
C  END LOOP SYMM.OP.
C
      TEMP(I)=EXP(-XL(I+IOF,4)*SSNN)
      SA(I)=SAI
      SB(I)=SBI
      NI=PTR(I+IOF,1)
      BNI=DFPP(NI)
      IF(NSCAT.LT.0.AND.NI.LE.IABS(NSCAT)) THEN       !---14
        RSTAR=SQRT(SSNN)*2000.0
        CALL SFINT(RSTAR,NI,FFX)
        FFX=FFX+DFP(NI)
       ELSE
        FFX=DFP(NI)+AC(9,NI)
        DO 302 II=1,7,2
 302    FFX=FFX+AC(II,NI)*EXP(-AC(II+1,NI)*SSNN)
      ENDIF                                           !---14
      SNEXI=FFX*XL(I+IOF,5)*TEMP(I)
      SNXI=BNI*XL(I+IOF,5)*TEMP(I)
C-----CALCULATE A AND B OF F
      AV=SNEXI*SAI+AV
      SNEX(I)=2.*SNEXI*TAV*RATIO(IX)
      SNX(I)=2.*SNXI*TAV*RATIO(IX)
      CV=CV+SNXI*SAI
      IF(ICENT.EQ.1) THEN                             !---15
       DV=DV+SNXI*SBI
       BV=SNEXI*SBI+BV
      ENDIF                                           !---15
c-----------------------------------------------------
    8 CONTINUE       !End loop over atoms (FNN calc) (end numbering IF-blocks
c-----------------------------------------------------
      ort_bs_m=.true.      !no more writings in *.bs,*.m,*.ort files!!
c
c Add constant part of structure factor of the 'host' (i.e. zeolites)
c
      if(irf(iph).eq.3.or.irf(iph).eq.-4) then
        AV=AV+ASFA(NN)
        BV=BV+BSFA(NN)
       else
        ASFA(NN)=AV-DV
        BSFA(NN)=BV+CV
      endif
C-----CALCULATE THE PHASE IN RADIANS
      FNN=CV*CV+AV*AV+DV*DV+BV*BV
C
C     FNN = AV*AV+BV*BV+CV*CV+DV*DV+2.*(BV*CV-AV*DV) !For a single crystal
C
C FNN for single crystal is necessary for phase calculation in Fourier map
C (important for X-rays with strong anomalous scattering and non-centro S.G)
C
      DFANOM=FNN+2.*(BV*CV-AV*DV)
      PHASEN(NN)=0.
      arg3=(BV+CV)/SQRT(DFANOM)
      if(abs(arg3).gt.1.0) arg3=sign(1.0,arg3)
      IF (DFANOM.NE.0.) PHASEN(NN)=ASIN(arg3)
      IF ((AV-DV).LT.0.)PHASEN(NN)=PI-PHASEN(NN)
      IF (PHASEN(NN).LT.0.) PHASEN(NN)=PHASEN(NN)+2.*PI
      FNN=RATIO(IX)*FNN*TAV
      IF(MAXS.EQ.0)RETURN
C--------------------------------------------------------------------------C
C---------------------- CALCULATE DERIVATIVES -----------------------------C
C--------------------------------------------------------------------------C
      DO 17 I=1,N
      SNEXI=SNEX(I)
      SNXI=SNX(I)
      SAI=SA(I)
      SBI=SB(I)
      IF(NUM(I+IOF).EQ.0) THEN
c------free atom
        JSTART=1
        JEND=14
       ELSE
c------RBG
        JSTART=4
        JEND=5
      END IF
      DO 22 J=JSTART,JEND
      K=LP(I+IOF,J)
      IF(K.EQ.0) GOTO 22
      IF(J.GT.5) GOTO 221
      IF(J.GT.3) GOTO 29
      SUMA=SUMAX(I,J)
      SUMB=SUMBX(I,J)
      DER=-((AV*SUMA-BV*SUMB)*SNEXI+(CV*SUMA-DV*SUMB)*SNXI)*2.*PI
      GOTO 26
   29 IF(J.GT.4)GOTO 31
      DER=-((SAI*AV+SBI*BV)*SNEXI+(SAI*CV+SBI*DV)*SNXI)*SSNN
      GOTO 26
   31 DER=((SAI*AV+SBI*BV)*SNEXI+(SAI*CV+SBI*DV)*SNXI)/XL(I+IOF,5)
      GOTO 26
  221 SUMA=SUMAX(I,J-5)
      SUMB=SUMBX(I,J-5)
      DER=-((AV*SUMA+BV*SUMB)*SNEXI+(CV*SUMA+DV*SUMB)*SNXI)
      IF(J.GE.11) DER=2.*DER
   26 DERI(K) = SIGN(1.,A(I+IOF,J))*DER+DERI(K)
   22 CONTINUE
   17 CONTINUE
c------------------------------------------------------------------------
c-------------------- derivative of rbg parameters ----------------------
c------------------------------------------------------------------------
      IF((NG-IGR_OFF).EQ.0) RETURN      !no rbg
c----------------------------------
c----preparation of the derivatives
c----------------------------------
      DO IG=IGR_OFF+1,NG
c------initializing translations
        DO J=1,3
          XDPAR(J,IG)=0.
        END DO
      END DO
      IG=IGR_OFF
      DO I=1,N
        IF(NUM(I+IOF).EQ.0) GOTO 900
        IF(NUM(I+IOF).EQ.1) THEN
          IG=IG+1
c--------satellite group
          IF(IGR(IG).NE.0) KG=IGR(IG)
        END IF
        SNEXI=SNEX(I)
        SNXI=SNX(I)
        DO J=1,3
          DX(J)=-((AV*SUMAX(I,J)-BV*SUMBX(I,J))*SNEXI
     *           +(CV*SUMAX(I,J)-DV*SUMBX(I,J))*SNXI )*2.*pi
c
c--------translation x,y and z for each group within the cell
          IF(IGR(IG).NE.0) THEN
c--------satellite
            XDPAR(J,KG)=XDPAR(J,KG)+DX(J)
           ELSE
c--------rbg
            XDPAR(J,IG)=XDPAR(J,IG)+DX(J)
          ENDIF
        END DO
c------transformation of reduced coordinate derivatives in normal derivatives
        DO K=1,3
          XI(K)=0.
          DO L=1,3
            XI(K)=XI(K)+DX(L)*FMAT(K,L,IPH)
          END DO
        END DO
c------storage of the derivatives
        DX0(I+IOF)=XI(1)
        DY0(I+IOF)=XI(2)
        DZ0(I+IOF)=XI(3)
c
c       print'(a,3f10.4)','--> dx : ' ,(dx(j),j=1,3)
c       print'(a,3f10.4)','--> dX : ' ,dx0(i+iof),dy0(i+iof),
c     *                                 dz0(i+iof)
c
900     CONTINUE
      END DO
c-------------------------------
c----calculating each derivative
c-------------------------------
c----preliminary
      ntls=mpardeb      !counter for each rbg/TLS
      IG=IGR_OFF
      DO I=1,N
        IF(NUM(I+IOF).EQ.0) GOTO 1000
        IF(NUM(I+IOF).EQ.1) THEN
          IG=IG+1
          IPIOF=I+IOF
          IF(IGR(IG).EQ.0) THEN
c--------rbg
c----------translation of the rbg: contain the satellite contribution
            DO L=12,14
              KC=LP(IPIOF,L)
              IF(KC.NE.0) DERI(KC)=XDPAR(L-11,IG)*
     *                    SIGN(1.,A(IPIOF,L))+DERI(KC)
            END DO
           ELSE
c----------satellite group : Theta,phi and chi of satellites are not refinable
            KG=IGR(IG)
            JPIOF=ISAT(IG,1)
c           JKTH=LP(JPIOF,7)
c           JKPH=LP(JPIOF,8)
c           JKCH=LP(JPIOF,15)
          END IF
        END IF
c------for all atoms
        IF(IGR(IG).EQ.0) THEN
c--------rbg
          call get_der_rbg(xth(ig),xph(ig),chi(ig),
     *                     dist(i+iof),alpha(i+iof),Rz(i+iof),
     *                     dv0)
c--------Xth(IG)
          KK=LP(IPIOF,7)
          IF(KK.NE.0) THEN
            k=1
            DER=DX0(I+IOF)*dv0(k,1)+DY0(I+IOF)*dv0(k,2)+
     *          DZ0(I+IOF)*dv0(k,3)
            DERI(KK)=DER*SIGN(1.,A(IPIOF,7))+DERI(KK)
          ENDIF
c--------Xph(IG)
          KK=LP(IPIOF,8)
          IF(KK.NE.0) THEN
            k=2
            DER=DX0(I+IOF)*dv0(k,1)+DY0(I+IOF)*dv0(k,2)+
     *          DZ0(I+IOF)*dv0(k,3)
            DERI(KK)=DER*SIGN(1.,A(IPIOF,8))+DERI(KK)
          ENDIF
c--------CHI(IG)
          KK=LP(IPIOF,15)
          IF(KK.NE.0) THEN
            k=3
            DER=DX0(I+IOF)*dv0(k,1)+DY0(I+IOF)*dv0(k,2)+
     *          DZ0(I+IOF)*dv0(k,3)
            DERI(KK)=DER*SIGN(1.,A(IPIOF,15))+DERI(KK)
          ENDIF
c--------the following derivatives of the rbg take no account of the satellite
c--------DIST(I+IOF)
          KK=LP(I+IOF,9)
          IF(KK.NE.0) THEN
            k=4
            DER=DX0(I+IOF)*dv0(k,1)+DY0(I+IOF)*dv0(k,2)+
     *          DZ0(I+IOF)*dv0(k,3)
            DERI(KK)=DER*SIGN(1.,A(I+IOF,9))+DERI(KK)
          ENDIF
c--------ALPHA(I+IOF)
          KK=LP(I+IOF,10)
          IF(KK.NE.0) THEN
            k=5
            DER=DX0(I+IOF)*dv0(k,1)+DY0(I+IOF)*dv0(k,2)+
     *          DZ0(I+IOF)*dv0(k,3)
            DERI(KK)=DER*SIGN(1.,A(I+IOF,10))+DERI(KK)
          ENDIF
c--------Rz(I+IOF)
          KK=LP(I+IOF,11)
          IF(KK.NE.0) THEN
            k=6
            DER=DX0(I+IOF)*dv0(k,1)+DY0(I+IOF)*dv0(k,2)+
     *          DZ0(I+IOF)*dv0(k,3)
            DERI(KK)=DER*SIGN(1.,A(I+IOF,11))+DERI(KK)
          ENDIF
         ELSE
c-------satellite: XTH, XPH and Chi are not refined within the satellite reference
c--------Transform normal coordinates to internal cartesian coordinates
c--------First multiply by the tranpose(inverse) of XA
          dx(1)=X0(JPIOF)-X0(I+IOF)
          dx(2)=Y0(JPIOF)-Y0(I+IOF)
          dx(3)=Z0(JPIOF)-Z0(I+IOF)
          DO K=1,3
            XI(K)=0.
            DO L=1,3
              XI(K)=XI(K)+DX(L)*XA(L,K,KG)  !Intermediate frame
            END DO
          END DO
          DO K=1,3
            Dx(K)=0.
            DO L=1,3
              Dx(K)=Dx(K)+XI(L)*XAP(L,K,KG)  !Now Dx can be used for getting
            END DO                           !Internal spherical coordinates
          END DO
c--------spherical coordinates
          call get_spheric_coord(dx,xdist,xalpha,xphi)
          call arrange(xalpha,1)
          call arrange(xphi,1)
c--------
          call get_der_rbg(xth(kg),xph(kg),chi(kg),
     *                     xdist,xalpha,xphi,dv0)
c--------Xth(NG) -> of main RBG
          KK=LP(JPIOF,7)
          IF(KK.NE.0) THEN
            k=1
            DER=DX0(I+IOF)*dv0(k,1)+DY0(I+IOF)*dv0(k,2)+
     *          DZ0(I+IOF)*dv0(k,3)
            DERI(KK)=DER*SIGN(1.,A(JPIOF,7))+DERI(KK)
          ENDIF
c--------Xph(IG) -> of main RBG
          KK=LP(JPIOF,8)
          IF(KK.NE.0) THEN
            k=2
            DER=DX0(I+IOF)*dv0(k,1)+DY0(I+IOF)*dv0(k,2)+
     *          DZ0(I+IOF)*dv0(k,3)
            DERI(KK)=DER*SIGN(1.,A(JPIOF,8))+DERI(KK)
          ENDIF
c--------CHI(IG) -> of main RBG
          KK=LP(JPIOF,15)
          IF(KK.NE.0) THEN
            k=3
            DER=DX0(I+IOF)*dv0(k,1)+DY0(I+IOF)*dv0(k,2)+
     *          DZ0(I+IOF)*dv0(k,3)
            DERI(KK)=DER*SIGN(1.,A(JPIOF,15))+DERI(KK)
          ENDIF
c------- refinement of dist, alpha and Rz must be done in the satellite frame
          call get_der_rbg(xth(ig),xph(ig),chi(ig),
     *                     dist(i+iof),alpha(i+iof),Rz(i+iof),
     *                     dv0)
c--------DIST(I+IOF)
          KK=LP(I+IOF,9)
          IF(KK.NE.0) THEN
            k=4
            DER=DX0(I+IOF)*dv0(k,1)+DY0(I+IOF)*dv0(k,2)+
     *          DZ0(I+IOF)*dv0(k,3)
            DERI(KK)=DER*SIGN(1.,A(I+IOF,9))+DERI(KK)
          ENDIF
c--------ALPHA(I+IOF)
          KK=LP(I+IOF,10)
          IF(KK.NE.0) THEN
            k=5
            DER=DX0(I+IOF)*dv0(k,1)+DY0(I+IOF)*dv0(k,2)+
     *          DZ0(I+IOF)*dv0(k,3)
            DERI(KK)=DER*SIGN(1.,A(I+IOF,10))+DERI(KK)
          ENDIF
c--------Rz(I+IOF)
          KK=LP(I+IOF,11)
          IF(KK.NE.0) THEN
            k=6
            DER=DX0(I+IOF)*dv0(k,1)+DY0(I+IOF)*dv0(k,2)+
     *          DZ0(I+IOF)*dv0(k,3)
            DERI(KK)=DER*SIGN(1.,A(I+IOF,11))+DERI(KK)
          ENDIF
        ENDIF
c
c------TLS derivatives for rbg and satellites
c
        if(abs(iopt(ig)).eq.5.or.
     *   (abs(iopt(ig)).eq.2.and.abs(iopt(igr(ig))).eq.5)) then
c--------finds the correct rbg/tls
          if(num(i+iof).eq.1) then
            if(abs(iopt(ig)).eq.2) then !satellite
              jg=igr(ig)
             else                               !main group
              jg=ig
            end if
          end if
c--------set the correct offset in additionnal parameters for each phase
          if(itls(ig).eq.0) then
            ntls=ntls-21                !satellites
           else
            if(num(i+iof).ne.1) ntls=ntls-21   !other atoms of a new main rbg
          end if
c--------finds the TLS parameters to refine
          do kk=1,21
            ktl=lpar(iph,ntls+kk)
            if(ktl.ne.0) then
              suma=sumatl(i,kk)
              sumb=sumbtl(i,kk)
              der=((av*suma+bv*sumb)*snex(i)
     *            +(cv*suma+dv*sumb)*snx(i) )
              deri(ktl)=deri(ktl)+sign(1.,apar(iph,ntls+kk))*der
            end if
          end do
          ntls=ntls+21
        end if
c------end of derivative calculations for each atom
1000    CONTINUE
      END DO
      RETURN
      END
C****************************************************************************C
        subroutine get_info(text,name,number)
c       *************************************
c       to get the label and the number of the atom in the rbg if any
c       compatible with new readnews free format for *.pcr files
c-----------------------------------------------------------------------------
        character text*4,name*2
c-----------------------------------------------------------------------------
        l=lenstr(text)
        jc=48
        ipos=0
        i=1
10      if(text(i:i).eq.char(jc)) then
          ipos=i
         else
          if(jc.le.57) then
            jc=jc+1
            goto 10
           else
            if(i.le.l) then
              jc=48
              i=i+1
              goto 10
             else
c------------free atom
              name(1:2)=text(1:2)
              number=0
              return
            end if
          end if
        endif
c------rbg
        name(1:2)=text(1:ipos-1)
        read(text(ipos:4),*) number
        return
        end
C****************************************************************************C
        SUBROUTINE ARRANGE(X,IOPT)
c       *************************
c       transforms reduced coordinate between 0 and 1 for iopt=0
c       transforms angles in radians between -pi and +pi
C--------------------------------------------------------------------------
        PI=ACOS(-1.)
        IF (IOPT.EQ.1) GOTO 30
C-----reduced coordinates
5       IF(X.GE.-1.0.AND.X.LE.1.0) RETURN
        IF(X.LT.-1.0) THEN
          X=X+1.0
          GOTO 5
         ELSE
          IF(X.GT.1.0) THEN
            X=X-1.0
            GOTO 5
          END IF
        END IF
        return
C------ANGLES
30      IF(X.GE.-PI.AND.X.LE.PI) RETURN
        IF(X.LT.-PI) THEN
          X=X+2.*PI
          GOTO 30
         ELSE
          IF(X.GT.PI) THEN
            X=X-2.*PI
            GOTO 30
          END IF
        END IF
        RETURN
        END
C*************************************************************************
      subroutine get_spheric_coord(Xo,ss,theta,phi)
      dimension xo(3)
      pi=acos(-1.0)
       ss=0.0
        do j=1,3
         ss=ss+XO(j)*XO(j)
        end do
       ss=sqrt(ss)
       if(ss.gt.0.0) then
        theta=xo(3)/ss
        if(abs(theta).gt.1.0) then
          theta=sign(1.,theta)
        endif
          theta=acos(theta)
        if(abs(theta).lt.1.e-6.or.abs(theta-pi).lt.1.e-6) then
          Phi=0.0
         else
          Phi=atan2(xo(2),xo(1))
        endif
       else
        theta=0.0
        Phi=0.0
       endif
      return
      end
c-------------------------------------------------------
      SUBROUTINE COMMENTS4(K)
      include 'ful0.inc'
C
C   This subroutine writes in file *.out information given by the user
C   concerning his(her) explanation about the use of parameters in STRMOD
C   K: No. of the current Phase for which JBT=4
C
      character*60 info_rbg_tls
      common/inforbg/info_rbg_tls
      WRITE(i_out,10) info_rbg_tls
10    FORMAT(//,
     *'==> General Rigid-Body-constraints/TLS Subroutine for Rietveld ',
     *    'Refinements <==',/,a,/,
     *'                 See Fullprof Manual for more informations'/,
     *'                      *******************************'/)
      RETURN
      END
c------------------------------------------------------------------------------
        subroutine get_atomic_mass(atmtyp,w,ierr)
c       **************************************************************
c       calculates the centre of mass of a rigid-body-group (Fullprof)
c       **************************************************************
        parameter (iatome=98)
        character*2 atmtyp,atm(iatome)
        character*1 car(2)
        real*4 mass(iatome),w
c---------------------------------
        data (atm(i),i=1,iatome) /
c1
     *  'H ','D ',
c2
     *  'LI','BE','B ','C ','N ','O ','F ',
c3
     *  'NA','MG','AL','SI','P ','S ','CL',
c4
     *  'K ','CA','SC','TI','V ','CR','MN','FE','CO','NI','CU','ZN',
     *  'GA','GE','AS','SE','BR',
c5
     *  'RB','SR','Y ','ZR','NB','MO','TC','RU','RH','PD','AG','CD',
     *  'IN','SN','SB','TE','I ',
c6
     *  'CS','BA','LA','HF','TA','W ','RE','OS','IR','PT','AU','HG',
     *  'TL','PB','BI','PO','AT',
c7
     *  'FR','RA','AC',
cla
     *  'CE','PR','ND','PM','SM','EU','GD','TB','DY','HO','ER','TM',
     *  'YB','LU',
cac
     *  'TH','PA','U ','NP','PU','AM','CM','BK','CF','ES','FM','MD',
     *  'NO','LR'/
c----------------------------------
        data (mass(i),i=1,iatome) /
c1
     *  1.00,2.00,
c2
     *  6.94, 9.01, 10.81, 12.01, 14.01, 16.00, 19.00,
c3
     *  22.99, 24.31, 26.98, 28.09, 30.97, 32.06, 35.45,
c4
     *  39.10, 40.08, 44.96, 47.90, 50.94, 52.00, 54.94,
     *  55.85, 58.93, 58.71, 63.55, 65.38, 69.74, 72.59,
     *  74.92, 78.96, 79.90,
c5
     *  85.47, 87.62, 88.91, 91.22, 92.91, 95.94, 98.91, 101.07, 102.91,
     *  106.40, 107.87, 112.41, 114.82, 118.69, 121.75, 127.60, 126.90,
c6
     *  132.91, 137.33, 138.91, 178.49, 180.95, 183.85, 186.21, 190.20,
     *  192.22, 195.09, 196.97, 200.59, 204.37, 207.20, 208.98, 209.00,
     *  210.00,
c7
     *  223.00, 226.03, 227.00,
cla
     *  140.12, 140.91, 144.24, 145.00, 150.40, 151.96, 157.25, 158.93,
     *  162.50, 164.93, 167.26, 168.93, 173.04, 174.97,
cac
     *  232.04, 231.04, 238.03, 237.05, 244.00, 243.00, 247.00, 247.00,
     *  251.00, 254.00, 257.00, 258.00, 259.00, 260.00/
c---------------------------------------------------------------------
        ierr=0
        do i=1,2
          car(i)=atmtyp(i:i)
          icar=ichar(car(i))
          if(icar.ge.97.and.car(i).ne.' ') car(i)=char(icar -32)
          atmtyp(i:i)=car(i)
        end do
        do i=1,iatome
c--------consults the data set to recognize the atome
          if(atmtyp.eq.atm(i)) then
            w=mass(i)
            return
          end if
        end do
        ierr=1
        return
        end
c---------------------------------------------------------------------
        subroutine get_tls_derivatives(hkl,cmat,x,y,z,der)
c       --------------------------------------------------
c       results taken from MAPLE
c
        dimension hkl(3),cmat(3,3),der(21)
c------------------------------------------
c------definitions
        h=hkl(1)
        k=hkl(2)
        l=hkl(3)
        pi=acos(-1.)
        pi2=pi*pi
        c11=cmat(1,1)
        c12=cmat(1,2)
        c13=cmat(1,3)
c       c21=cmat(2,1)
        c22=cmat(2,2)
        c23=cmat(2,3)
c       c31=cmat(3,1)
c       c32=cmat(3,2)
        c33=cmat(3,3)
c----derivatives of T
      DER(1) = -4*k*l*pi2*c13*c12-2*k**2*pi2*c12**2-2*h**2*pi2*
     #c11**2-4*h*k*pi2*c11*c12-4*h*l*pi2*c11*c13-2*l**2*pi2*c13**2
c
      DER(2) = -4*k*l*pi2*c23*c22-2*k**2*pi2*c22**2-2*l**2*pi2*
     #c23**2
c
      DER(3) = -2*l**2*pi2*c33**2
c
      DER(4) = -4*k*l*pi2*c23*c12-4*k*l*pi2*c13*c22-4*l**2*pi2*
     #c13*c23-4*h*l*pi2*c11*c23-4*h*k*pi2*c11*c22-4*k**2*pi2*c12*c
     #22
c
      DER(5) = -4*l**2*pi2*c13*c33-4*k*l*pi2*c33*c12-4*h*l*pi2*
     #c11*c33
c
      DER(6) = -4*k*l*pi2*c33*c22-4*l**2*pi2*c23*c33
c
c----derivatives of L
      DER(7) = -4*k*l*pi2*c23*c22*z**2+4*k*l*pi2*c33*c22*y*z-2*l*
     #*2*pi2*c23**2*z**2-2*k**2*pi2*c22**2*z**2+4*l**2*pi2*c23*c33
     #*y*z-2*l**2*pi2*c33**2*y**2
c
      DER(8) = -4*k*l*pi2*c13*c12*z**2+4*k*l*pi2*c33*c12*x*z-2*l**2
     #*pi2*c13**2*z**2-2*h**2*pi2*c11**2*z**2-2*l**2*pi2*c33**2*
     #x**2-4*h*l*pi2*c11*c13*z**2
      DER(8) =DER(8)-4*h*k*pi2*c11*c12*z**2-2*k**2*Pi2
     #*c12**2*z**2+4*h*l*pi2*c11*c33*x*z+4*l**2*pi2*c13*c33*x*z
c
      DER(9) = -4*k*l*pi2*c13*c12*y**2-2*k**2*pi2*c22**2*x**2-4*k
     #*l*pi2*c23*c22*x**2-2*h**2*pi2*c11**2*y**2+4*l**2*pi2*c13*c23*
     #x*y-2*l**2*pi2*c23**2*x**2-4*h*l*pi2*c11*c13*y**2
      DER(9) = DER(9) -4*h*k*pi2*c11*c12*y**2+4*h*k*pi2*c11*c22*x*y
     #+4*h*l*pi2*c11*c23*x*y-2*k**2*pi2*c12**2*y**2
      DER(9) = DER(9)  +4*k*l*pi2*c13*c22*x*y+4*k**2*pi2*c12*c22
     #*x*y+4*k*l*pi2*c23*c12*x*y-2*l**2*pi2*c13**2*y**2
c
      DER(10) = 4*k*l*pi2*c13*c22*z**2+4*l**2*pi2*c33**2*x*y-4*k*l
     #*pi2*c33*c12*y*z-4*k*l*pi2*c33*c22*x*z+4*l**2*pi2*c13*c23*z*
     #*2+4*h*l*pi2*c11*c23*z**2+4*h*k*pi2*c11*c22*z**2
      DER(10) = DER(10) -4*h*l*pi2*c11*c33*y*z
     #+4*k**2*pi2*c12*c22*z**2+4*k*l*pi2*c23*c12*z**2
     #-4*l**2*pi2*c23*c33*x*z-4*l**2*pi2*c13*c33*y*z
c
      DER(11) = -4*k*l*pi2*c13*c22*y*z-4*k*l*pi2*c33*c22*x*y+4*k*l
     #*pi2*c33*c12*y**2+4*l**2*pi2*c13*c33*y**2-4*l**2*pi2*c13*c23
     #*y*z-4*h*l*pi2*c11*c23*y*z-4*h*k*pi2*c11*c22*y*z
      DER(11)=DER(11)+4*h*l*pi2*c11*c33*y**2+4*k**2*pi2*c22**2*x*z
     #-4*k**2*pi2*c12*c22*y*z-4*k*l*pi2*c23*c12*y*z+8*k*l*pi2*c23*c22
     #*x*z-4*l**2*pi2*c23*c33*x*y+4*l**2*pi2*c23**2*x*z
c
      DER(12) = 4*k*l*pi2*c33*c22*x**2+8*k*l*pi2*c13*c12*y*z-4*k*l
     #*pi2*c13*c22*x*z-4*k*l*pi2*c33*c12*x*y+4*l**2*pi2*c13**2*y*z
     #-4*l**2*pi2*c13*c23*x*z+4*h**2*pi2*c11**2*y*z
      DER(12)=DER(12) -4*h*l*pi2*c11*c23*x*z-4*h*k*pi2*c11*c22*x*z
     #+8*h*k*pi2*c11*c12*y*z+8*h*l*Pi2*c11*c13*y*z
     #+4*k**2*pi2*c12**2*y*z-4*k**2*pi2*c12*c22*x*z
      DER(12)=DER(12) -4*h*l*pi2*c11*c33*x*y
     #-4*k*l*pi2*c23*c12*x*z+4*l**2*pi2*c23*c33*x**2
     #-4*l**2*pi2*c13*c33*x*y
c
c----derivatives of S
c
c    s33 : s11+s22+s33 = 0 (condition) => we can choose s33 = -s11-s22
c                                      => ds33=-ds11-ds22
c
      DER(13) = 4*k*l*pi2*c13*c22*z-8*k*l*pi2*c33*c12*y+4*k*l*Pi2
     # *c23*c12*z+4*h*l*pi2*c11*c23*z+4*h*k*pi2*c11*c22*z-8*h*l*Pi2
     # *c11*c33*y+4*k**2*pi2*c12*c22*z-8*l**2*pi2*c13*c33*y
      DER(13) = DER(13) +4*l**2*Pi2*c13*c23*z
     #+4*k*l*pi2*c33*c22*x+4*l**2*pi2*c23*c33*x
c
      DER(14) = 8*k*l*pi2*c33*c22*x-4*k*l*pi2*c13*c22*z-4*h*l*Pi2
     # *c11*c23*z-4*h*k*pi2*c11*c22*z-4*k**2*pi2*c12*c22*z
      DER(14) =DER(14) -4*k*l*Pi2*c23*c12*z
     # +8*l**2*pi2*c23*c33*x-4*l**2*pi2*c13*c23*z-4*k*l*Pi2
     # *c33*c12*y-4*h*l*pi2*c11*c33*y-4*l**2*pi2*c13*c33
c
       DER(15) = -DER(13) - DER(14)
c
      DER(16) = -4*k*l*pi2*c33*c22*y+4*l**2*pi2*c23**2*z+4*k**2*Pi
     #**2*c22**2*z+8*k*l*pi2*c23*c22*z-4*l**2*pi2*c23*c33*y
c
      DER(17) =  4*k*l*pi2*c33*c22*z-4*l**2*pi2*c33**2*y+4*l**2*Pi*
     #*2*c23*c33*z
c
      DER(18) =  -4*k*l*pi2*c33*c12*z+4*l**2*pi2*c33**2*x-4*h*l*Pi*
     #*2*c11*c33*z-4*l**2*pi2*c13*c33*z
c
      DER(19)=4*k*l*pi2*c33*c12*x-8*k*l*pi2*c13*c12*z-4*h**2*Pi2*c11**2
     #*z-8*h*k*pi2*c11*c12*z+4*h*l*pi2*c11*c33*x-4*k**2*Pi2*c12**2*z
      DER(19)=DER(19)-8*h*l*pi2*c11*c13*z+4*l**2*pi2*c13*c33*x
     #-4*l**2*Pi2*c13**2*z
c
      DER(20) = -4*k*l*pi2*c23*c12*x+4*l**2*pi2*c13**2*y-4*h*l*Pi*
     #*2*c11*c23*x-4*h*k*pi2*c11*c22*x+4*h**2*pi2*c11**2*y+8*h*k*Pi*
     #*2*c11*c12*y+8*h*l*pi2*c11*c13*y
      DER(20) =DER(20) -4*k**2*pi2*c12*c22*x+8*k*l*Pi2*c13*c12*y
     #+4*k**2*pi2*c12**2*y-4*k*l*pi2*c13*c22*x-4*l**2*Pi2*c13*c23*x
c
      DER(21)=4*l**2*pi2*c13*c23*y+4*k*l*pi2*c23*c12*y-4*l**2*Pi2*c23**2
     #*x+4*h*l*pi2*c11*c23*y+4*h*k*pi2*c11*c22*y
      DER(21)=DER(21)-4*k**2*Pi2*c22**2*x
     #+4*k**2*pi2*c12*c22*y+4*k*l*pi2*c13*c22*y-8*k*l*Pi2*c23*c22*x
c
        return
        end
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      FUNCTION SIND(X)
      SIND=SIN(1.74532925E-02*X)
      RETURN
      END
      FUNCTION COSD(X)
      COSD=COS(1.74532925E-02*X)
      RETURN
      END
      FUNCTION ASIND(X)
      ASIND=ASIN(X)*57.29577951
      RETURN
      END
      FUNCTION ACOSD(X)
      ACOSD=ACOS(X)*57.29577951
      RETURN
      END
c-------------------------------------------------------------------
      SUBROUTINE DIAG_TL(nom,rt,rl,ig,i_out,i_sum,ICYCLE_C,MCYCLE)
      dimension rt(6),rl(6),A(3,3),B(3),C(3,3)
      character text80*80,text*50,nom*2
      logical out_sum
      out_sum=ICYCLE_C.eq.MCYCLE
      text='    Eigen Value ---->    Eigen vector(Orth. syst.)'
      A(1,1)=rt(1)*100.00
      A(2,2)=rt(2)*100.00
      A(3,3)=rt(3)*100.00
      A(1,2)=rt(4)*100.00
      A(2,1)=A(1,2)
      A(1,3)=rt(5)*100.00
      A(3,1)=A(1,3)
      A(2,3)=rt(6)*100.00
      A(3,2)=A(2,3)
C------DIAGONALIZE A, PUT EIGENVALUES IN B AND EIGENVECTORS IN C
       call Mat3_diag(A,B,C)
      text80=
     +' => Diagonalization of T-tensor(100xAngstroms**2) of RBG no.'
      lo=lenstr(text80)
      write(i_out,'(a,i2,3a)') text80(1:lo),ig,'(',nom, ')'
      write(i_out,'(a)') text
      if(out_sum) then
       write(i_sum,'(/a/)')
     +' => TL-tensors of RBG defined for the refined phase(s) below:'
       write(i_sum,'(a,i2,3a)') text80(1:lo),ig,'(',nom, ')'
       write(i_sum,'(a)') text
      endif
      DO  I =1,3
        write(i_out,10) B(I),C(1,I),C(2,I),C(3,I)
        if(out_sum) write(i_sum,10) B(I),C(1,I),C(2,I),C(3,I)
      end do
  10  FORMAT((3x,F10.4,'   ----',3(1x,F10.5)))
      A(1,1)=rl(1)*3282.8063498  !(180/pi)**2
      A(2,2)=rl(2)*3282.8063498
      A(3,3)=rl(3)*3282.8063498
      A(1,2)=rl(4)*3282.8063498
      A(2,1)=A(1,2)
      A(1,3)=rl(5)*3282.8063498
      A(3,1)=A(1,3)
      A(2,3)=rl(6)*3282.8063498
      A(3,2)=A(2,3)
       call Mat3_diag(A,B,C)
      text80=
     + ' => Diagonalization of L-tensor(degrees**2) of RBG no. '
      lo=lenstr(text80)
      write(i_out,'(a,i2,3a)') text80(1:lo),ig,'(',nom, ')'
      write(i_out,'(a)') text
      if(out_sum) then
       write(i_sum,'(a,i2,3a)') text80(1:lo),ig,'(',nom, ')'
       write(i_sum,'(a)') text
      endif
      DO  I =1,3
        write(i_out,10) B(I),C(1,I),C(2,I),C(3,I)
        if(out_sum) write(i_sum,10) B(I),C(1,I),C(2,I),C(3,I)
      end do
        if(out_sum) write(i_sum,'(a)') ' '
      return
      end
c--------------------------------------------------------------------------
          subroutine get_der_rbg(xth,xph,chi,dist,alpha,Rz,dV0)
c------ calculate derivatives for each atom of theta, phi, chi
c------ dist, alpha and Rz
        dimension dV0(6,3)
c------ Xth(ig)
      dV0(1,1) = -cos(xph)*sin(xth)*dist*sin(alpha)*cos(Rz+chi)+cos(
     #xph)*cos(xth)*dist*cos(alpha)
      dV0(1,2) =  -sin(xph)*sin(xth)*dist*sin(alpha)*cos(Rz+chi)+sin(
     #xph)*cos(xth)*dist*cos(alpha)
      dV0(1,3) = -cos(xth)*dist*sin(alpha)*cos(Rz+chi)-sin(xth)*dist
     #*cos(alpha)
c------ Xph(ig)
      dV0(2,1) = -sin(xph)*cos(xth)*dist*sin(alpha)*cos(Rz+chi)-cos(xp
     #h)*dist*sin(alpha)*sin(Rz+chi)-sin(xph)*sin(xth)*dist*cos(alpha)
      dV0(2,2) =  cos(xph)*cos(xth)*dist*sin(alpha)*cos(Rz+chi)-sin(xph
     #)*dist*sin(alpha)*sin(Rz+chi)+cos(xph)*sin(xth)*dist*cos(alpha)
      dV0(2,3) = 0.
c------ CHI(IG)
      dV0(3,1) = -cos(xph)*cos(xth)*dist*sin(alpha)*sin(Rz+chi)-sin(xp
     #h)*dist*sin(alpha)*cos(Rz+chi)
      dV0(3,2) = -sin(xph)*cos(xth)*dist*sin(alpha)*sin(Rz+chi)+cos(xp
     #h)*dist*sin(alpha)*cos(Rz+chi)
      dV0(3,3) = sin(xth)*dist*sin(alpha)*sin(Rz+chi)
c------ dist(i+iof)
      dV0(4,1) = cos(xph)*cos(xth)*sin(alpha)*cos(Rz+chi)-sin(xph)*si
     #n(alpha)*sin(Rz+chi)+cos(xph)*sin(xth)*cos(alpha)
      dV0(4,2) = sin(xph)*cos(xth)*sin(alpha)*cos(Rz+chi)+cos(xph)*si
     #n(alpha)*sin(Rz+chi)+sin(xph)*sin(xth)*cos(alpha)
      dV0(4,3) = -sin(xth)*sin(alpha)*cos(Rz+chi)+cos(xth)*cos(alpha)
c------ alpha(i+iof)
      dV0(5,1) = cos(xph)*cos(xth)*dist*cos(alpha)*cos(Rz+chi)-sin(x
     #ph)*dist*cos(alpha)*sin(Rz+chi)-cos(xph)*sin(xth)*dist*sin(alpha)
      dV0(5,2) = sin(xph)*cos(xth)*dist*cos(alpha)*cos(Rz+chi)+cos(x
     #ph)*dist*cos(alpha)*sin(Rz+chi)-sin(xph)*sin(xth)*dist*sin(alpha)
      dV0(5,3) = -sin(xth)*dist*cos(alpha)*cos(Rz+chi)-cos(xth)*dist
     #*sin(alpha)
c------ Rz(i+iof)
      dV0(6,1) = -cos(xph)*cos(xth)*dist*sin(alpha)*sin(Rz+chi)-sin(xph
     #)*dist*sin(alpha)*cos(Rz+chi)
      dV0(6,2) = -sin(xph)*cos(xth)*dist*sin(alpha)*sin(Rz+chi)+cos(xph
     #)*dist*sin(alpha)*cos(Rz+chi)
      dV0(6,3) = sin(xth)*dist*sin(alpha)*sin(Rz+chi)
c
c       do i=1,6
c        print'(a,3f10.4)','--> dv0 : ',(dv0(i,j),j=1,3)
c       enddo
        return
        end
C-----------------------------------------------------------------------
      subroutine get_dmetric(a,b,E)
      dimension a(3),b(3),e(3,3)
      external cosd
C-----------------------------------------------------------------------
C------ GET THE METRIC TENSOR E CORRESPONDING TO CELL EDGES A & ANGLES B
C-----------------------------------------------------------------------
       DO  I=1,3
        E(I,I)=A(I)*A(I)
       end do
      E(1,2)=A(1)*A(2)*COSD(B(3))
      E(2,1)=E(1,2)
      E(1,3)=A(1)*A(3)*COSD(B(2))
      E(3,1)=E(1,3)
      E(2,3)=A(2)*A(3)*COSD(B(1))
      E(3,2)=E(2,3)
      RETURN
      END
C-----------------------------------------------------------------------
       subroutine Mat3_diag(A,V,C)
       dimension A(3,3),V(3),U(3),C(3,3),E(3,3)
C-----------------------------------------------------------------------
C------DIAGONALIZE A, PUT EIGENVALUES IN B AND EIGENVECTORS IN C
C-----------------------------------------------------------------------
      N=3
      NM1=N-1
      EPS1=1.e-10
      EPS2=1.e-10
      EPS3=1.e-6
      ITMAX=50
      DO  I=1,N
        DO  J=1,N
        E(I,J)=A(I,J)
        C(I,J)=0.
        IF(J.LT.I) E(I,J)=0.
        end do
      end do
      SIGMA1=0.
      OFFDSQ=0.
      DO 5 I=1,N
        SIGMA1=SIGMA1+E(I,I)**2
        C(I,I)=1.
        IP1=I+1
        IF(I.GE.N) GOTO 6
      DO 5 J=IP1,N
    5 OFFDSQ=OFFDSQ+E(I,J)**2
c    6 S= 2.*OFFDSQ+SIGMA1
    6 continue
      DO 26 ITER=1,ITMAX
      DO 20 I=1,NM1
      IP1=I+1
      DO 20 J=IP1,N
      Q=ABS(E(I,I)-E(J,J))
      IF(Q.LE.EPS1) GOTO 9
      IF(ABS(E(I,J)).LE.EPS2) GOTO 20
      P=2.*E(I,J)*Q/(E(I,I)-E(J,J))
      SPQ=SQRT(P*P+Q*Q)
      CSA=SQRT((1.+Q/SPQ)/2.)
      SNA=P/(2.*CSA*SPQ)
      GOTO 10
    9 CSA=1./SQRT(2.)
      SNA=CSA
   10 CONTINUE
      DO 11 K=1,N
      HOLDKI=C(K,I)
      C(K,I)=HOLDKI*CSA+C(K,J)*SNA
   11 C(K,J)=HOLDKI*SNA-C(K,J)*CSA
      DO 16 K=I,N
      IF(K.GT.J) GOTO 15
      U(K)=E(I,K)
      E(I,K)=CSA*U(K)+SNA*E(K,J)
      IF(K.NE.J) GOTO 14
      E(J,K)=SNA*U(K)-CSA*E(J,K)
   14 GOTO 16
   15 HOLDIK=E(I,K)
      E(I,K)=CSA*HOLDIK+SNA*E(J,K)
      E(J,K)=SNA*HOLDIK-CSA*E(J,K)
   16 CONTINUE
      U(J)=SNA*U(I)-CSA*U(J)
      DO 19 K=1,J
      IF(K.LE.I) GOTO 18
      E(K,J)=SNA*U(K)-CSA*E(K,J)
      GOTO 19
   18 HOLDKI=E(K,I)
      E(K,I)=CSA*HOLDKI+SNA*E(K,J)
      E(K,J)=SNA*HOLDKI-CSA*E(K,J)
   19 CONTINUE
   20 E(I,J)=0.
      SIGMA2=0.
      DO 21 I=1,N
      V(I)=E(I,I)
   21 SIGMA2=SIGMA2+V(I)*V(I)
      IF(1.-SIGMA1/SIGMA2.LE.EPS3) GOTO 25
   26 SIGMA1=SIGMA2
      call stop_cond('Convergence not reached in diagonalization',0)
   25 return
       end
c---------------------------------------------------------------------
      subroutine matmult(a,b,c,n)
      dimension a(n,n),b(n,n),c(n,n)
       do i=1,n
        do j=1,n
        c(i,j)=0.0
         do k=1,n
          c(i,j)= c(i,j)+ a(i,k)*b(k,j)
         end do
        end do
       end do
      return
      end
c---------------------------------------------------------------------
      subroutine veclength(A,B,c)
       dimension a(3,3),b(3),v(3)
C-----------------------------------------------------------------------
C------LENGTH OF VECTOR B WHEN A IS THE CRYST. TO ORTHOGONAL MATRIX Length=c
C-----------------------------------------------------------------------
       DO I = 1,3
        V(I) = 0.0
          DO   J = 1,3
           V(I) = V(I)+A(I,J)*B(J)
          end do
       end do
       C = SQRT(V(1)**2+V(2)**2+V(3)**2)
       return
       end
c---------------------------------------------------------------------
       subroutine get_orthog(a,b,E)
       dimension a(3),b(3),e(3,3)
       external sind,cosd
C-----------------------------------------------------------------------
C------GET THE CRYST.-ORTHO. MATRIX E CORRESPONDING TO CELL EDGES A & B
C-----------------------------------------------------------------------
       COSGAS = (COSD(B(1))*COSD(B(2))-COSD(B(3)))
       COSGAS = COSGAS/(SIND(B(1))*SIND(B(2)))
       SINGAS = SQRT(1.-COSGAS**2)
       E(1,1) = A(1)*SIND(B(2))*SINGAS
       E(1,2) = 0.
       E(1,3) = 0.
       E(2,1) = -A(1)*SIND(B(2))*COSGAS
       E(2,2) = A(2)*SIND(B(1))
       E(2,3) = 0.
       E(3,1) = A(1)*COSD(B(2))
       E(3,2) = A(2)*COSD(B(1))
       E(3,3) = A(3)
       return
       end
c---------------------------------------------------------------------
      subroutine vecmat(v,a,w,n)
      dimension a(n,n),v(n),w(n)
       do i=1,n
        w(i)=0.0
        do j=1,n
        w(i)= w(i)+ v(j)*a(j,i)
        end do
       end do
      return
      end
c---------------------------------------------------------------------
      subroutine univec(v,u,sm,n)
      dimension v(n),u(n)
       sm=0.0
       do i=1,n
        sm=sm+v(i)*v(i)
       end do
       sm=sqrt(sm)
        do j=1,n
        u(j)= v(j)/sm
        end do
      return
      end
c---------------------------------------------------------------------
      subroutine matload(a,b,n)
      dimension a(n,n),b(n,n)
       do i=1,n
        do j=1,n
          b(i,j)= a(i,j)
        end do
       end do
      return
      end
c---------------------------------------------------------------------
c---------------------------------------------------------------------
      subroutine matrans(a,b,n)
      dimension a(n,n),b(n,n)
       do i=1,n
        do j=1,n
          b(i,j)= a(j,i)
        end do
       end do
      return
      end
c---------------------------------------------------------------------
c---------------------------------------------------------------------
      subroutine matvec(a,v,w,n)
      dimension a(n,n),v(n),w(n)
       do i=1,n
        w(i)=0.0
        do j=1,n
        w(i)= w(i)+ v(j)*a(i,j)
        end do
       end do
      return
      end
c----------------------------------------------------------------------
      subroutine matinv3(a,b,ifail)
      dimension a(3,3),b(3,3),e(3,3)
      eps=1.0e-20
C-----------------------------------------------------------------------
C------INVERT 3X3 MATRIX A, PUT THE RESULT IN B
C-----------------------------------------------------------------------
      E(1,1) = A(2,2)*A(3,3)-A(2,3)*A(3,2)
      E(2,1) = -(A(2,1)*A(3,3)-A(2,3)*A(3,1))
      E(3,1) = A(2,1)*A(3,2)-A(2,2)*A(3,1)
      E(1,2) = -(A(1,2)*A(3,3)-A(1,3)*A(3,2))
      E(2,2) = A(1,1)*A(3,3)-A(1,3)*A(3,1)
      E(3,2) = -(A(1,1)*A(3,2)-A(1,2)*A(3,1))
      E(1,3) = A(1,2)*A(2,3)-A(1,3)*A(2,2)
      E(2,3) = -(A(1,1)*A(2,3)-A(1,3)*A(2,1))
      E(3,3) = A(1,1)*A(2,2)-A(1,2)*A(2,1)
      DMAT = A(1,1)*E(1,1)+A(1,2)*E(2,1)+A(1,3)*E(3,1)
      ifail=0
      if(dmat.lt.eps) then
       ifail=1
       return
      endif
      DO I = 1,3
        DO J = 1,3
          B(I,J) = E(I,J)/DMAT
        end do
      end do
      return
      end
c------------------------------------------------------------------------
