C     Last change:  JRC   8 Mar 97    8:05 pm
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c     General rigid-body-constraints subroutine for Rietveld refinement
c               with TLS refinements (for all Space Groups)
c                       for rbg including satellites
c
c                    Revisited version for any OS/machine (?)
c
c                 Dr. Vincent Rodriguez
c                 Laboratoire de Spectroscopie Moleculaire et Cristalline *
c                 URA 124 CNRS
c                 Universite de Bordeaux I, 351 cours de la liberation
c                 33405 TALENCE Cedex France
c                 Phone: (++ 33) (0) 5 56 84 63 61
c                 Fax:   (++ 33) (0) 5 56 84 84 02
c                 e-mail vincent@loriot.lsmc.u-bordeaux.fr
c                 http://loriot.lsmc.u-bordeaux.fr
c
c                 * UMR Physico-Chimie Moleculaire since January 1st 1997
c                          ====================
c
c                         Version 1.4 - January 1997
c
C       With standard Euler angle notation
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c--------------------------------------------------------------------------
      SUBROUTINE First(IPH,N,IOF)
c----general parameters from main program
      INCLUDE 'ful0.inc'
      INCLUDE 'ful1.inc'
      INCLUDE 'ful2.inc'
      DIMENSION  XI(14),T(3),IM(3,3)
      DIMENSION  vaux1(3),vaux2(3),auxx(3,3)
      Integer  Mod6
      common/SymOpda/Mod6(36,3,3)
C----------------------------------------------------------------------------
c----rigid-body-constraints/TLS parameters
      PARAMETER (NGPMAX=10,MAXATOME=100)
      CHARACTER dumfile*80,dum*1
      CHARACTER info_rbg_tls*60,REC(maxatome)*2,TOBJ(ngpmax)*2
      common/inforbg/info_rbg_tls
      common/char_rbg/rec,tobj
      common/rbg_int/igr_off,ng,mpardeb,irbglabel,MYCYCLE,NUM(MAXATOME),
     * IOPT(NGPMAX),ISAT(NGPMAX,2),IGEN(NGPMAX),IGR(NGPMAX),
     * NGMAX(NPHT),IRIGID(NPHT),itls(ngpmax),ipg(ngpmax)
      common/rbg/X0(MAXATOME),Y0(MAXATOME),Z0(MAXATOME),
     *           DIST(MAXATOME),ALPHA(MAXATOME),RZ(MAXATOME),
     *           XTH(NGPMAX),XPH(NGPMAX),CHI(NGPMAX),
     *           XA(3,3,NGPMAX),XAP(3,3,NGPMAX),FMAT(3,3,NPHT),
     *           COG(3,NGPMAX),CMAT(3,3,NPHT),CTMAT(3,3,NPHT),
     *           COSAT1(NGPMAX,3),COSAT2(NGPMAX,3),rbgt(6,ngpmax),
     *           rbgl(6,ngpmax),sumatl(maxatome,21),sumbtl(maxatome,21),
     *           xog(3,ngpmax),tspg(4,3),rbgs(9,ngpmax),xcm(3,ngpmax),
     *           xmass(ngpmax), ad(3,npht),bd(3,npht)
      logical ort_bs_m,print_out
      common/plots_struct/ort_bs_m
C----------------------------------------------------------------------------C
      character dum_lab*3
      common/more_var/XDPAR(3,NGPMAX), DX0(MAXATOME),DY0(MAXATOME),
     *                DZ0(MAXATOME)
      dimension OTD(3,3),OTI(3,3),QQ(3,3),TOTI(3,3)
      dimension beta(3,3),bij(3,3),DX(3),qh(3)
      External acosd
C----------------------------------------------------------------------------C

c-----------------------------------------------------------------------------
c----------------loop over each first reflection of each phase ---------------
c-----------------------------------------------------------------------------
c
c----------------------
c----general parameters
c----------------------
      if(irbglabel.eq.0) then
        info_rbg_tls=
     *   'V.Rodriguez (v1.4) - LSMC/Universite Bx I - Jan 1997'
        irbglabel=1
        write(*,'(/,23X,a,//,15x,a,/,15x,a,/)')
     *   'Rigid-body-constraints / TLS option',info_rbg_tls,
     *   '===================================================='
        WRITE(i_out,'(/,23X,a,//,15x,a,/,15x,a,/)')
     *   'Rigid-body-constraints / TLS option',info_rbg_tls,
     *   '===================================================='
      print_out=.false.
      end if
      mpardeb=LASTMPAR !Last element used by fullprof in additional parameters
      ntls=mpardeb     !counter for rbg/tls option
      IRIGID(IPH)=1
      IF(N.GT.MAXATOME) THEN
        write(*,'(a,i3)')
     +    ' => Number of atoms greater than the maximum:',MAXATOME
        call stop_cond(' Too many atoms ',1)
      END IF
C----setting of the rbg offset
      IF(IPH.EQ.1) THEN
        IGR_OFF=0
        PI=ACOS(-1.)
       ELSE
        IGR_OFF=NGMAX(IPH-1)
      END IF
      if(.not.ort_bs_m) then
c----output files Molview and B&S
      l1=lenstr(filenam)
c----unit 20+iph molview file
      write(dumfile(1:l1+7),'(a,i1,a)') filenam(1:l1),iph,'.m    '
      OPEN(unit=19+iph,FILE=dumfile,STATUS='UNKNOWN')
      write(19+iph,653) info_rbg_tls,iph
653   FORMAT(
     *'= General Rigid-Body-Constraints/TLS file',
     *   ' Rietveld Refinement',/,
     *'= ',a,/,'= Phase Nr ',i1,/)
c-----unit 30+iph ball & sticks file
      write(dumfile(1:l1+7),'(a,i1,a)') filenam(1:l1),iph,'.bs   '
      OPEN(unit=29+iph,FILE=dumfile,STATUS='UNKNOWN')
      WRITE(29+iph,651) iph,info_rbg_tls
651   FORMAT('TITLE  Phase Nr ',i1,
     *' Rigid-Body-Constraints/TLS Rietveld Refinement ',a)
c---unit 40+iph is file"*.ortep" = atomic temperature factors
      write(dumfile(1:l1+7),'(a,i1,a)') filenam(1:l1),iph,'.ort'
      OPEN(unit=39+iph,FILE=dumfile,STATUS='UNKNOWN')
      endif
C----direct cell parameters ad and bd
      DO I=1,3
        AD(I,iph)=SAVE(IPH,I)
        BD(I,iph)=SAVE(IPH,I+3)
        vaux1(i)=SAVE(IPH,I)
        vaux2(i)=SAVE(IPH,I+3)
      END DO
c----calculations : reduced coordinates <-> orthogonal coordinates
c----OTD real orthogonal space : b is the reference axis -> OTD = matrix F
c      CALL MATRIX(AD,BD,OTD,QQ,'ORTHOG')
      call get_orthog(vaux1,vaux2,OTD)
c----OTI reverse operation, OTD calculation of inverse matrix -> OTI = matrix C
c      CALL MATRIX(OTD,OTI,QQ,auxx,'INVERT')
      call matinv3(OTD,OTI,ifail)
      if(ifail.eq.1) call stop_cond('Bad cell parameters!',1)
c----TOTI transpose matrix of OTI -> TOTI = Ct
c      CALL MATRIX(OTI,TOTI,QQ,auxx,'TRNSPS')
      call matrans(OTI,TOTI,3)
      DO I=1,3
        DO J=1,3
          FMAT(I,J,IPH)=OTD(I,J)
          CMAT(I,J,IPH)=OTI(I,J)
          CTMAT(I,J,IPH)=TOTI(I,J)
        END DO
      END DO
c----molview file
      if(.not.ort_bs_m)
     *write(19+iph,644) (ad(i,iph),i=1,3),(bd(i,iph),i=1,3)
644   format('cell    ',3(f7.3,5x),3(f7.2,5x),//,'localize',/,
     *  'showcell',/,'nobond',/)
c--------------------------------------------------------
c----loop over all atoms to define the rbg/tls parameters
c--------------------------------------------------------
      NG=IGR_OFF
C------------------------------------------------------------------------
      DO I=1,N                        !MAIN LOOP OVER ATOMS
C------------------------------------------------------------------------
        call get_info(atext(i+iof),rec(i+iof),num(i+iof)) !new Juan free format
c        read(ATEXT(I+IOF),'(A2,I2)') REC(I+IOF),NUM(I+IOF) ! old standard reading
        IF(NUM(I+IOF).NE.0) THEN
          IF(NUM(I+IOF).EQ.1) THEN
c----total number of groups
            NG=NG+1
            IF(NG.GT.(NGPMAX-1)) THEN
            write(*,'(a,i3)')
     +        ' => Number of groups greater than maximum: ',NGPMAX
              call stop_cond(' Too many groups ', 1)
            END IF
            IPIOF=I+IOF
c-------identification of the group
            TOBJ(NG)=REC(IPIOF)
c----looking for the requested option: abs(IOPT(NG))
c----if iopt(ng)<0 print to screen current informations of the group
C---------> abs(IOPT) = 1  rigid-body-constraints :default option
C--------->           = 2  rigid-body satellite group
C--------->           = 3  generating spherical coordinates from reduced ones.
C                          then Rbg option 1 is performed immediatly
C--------->           = 4  generating rigid-body-chain or so..Not tested
C--------->           = 5  rbg/tls with satellite groups if required
            if(icryg.eq.2) XL(IPIOF,6)=abs(XL(IPIOF,6)) !suppress writing
            IOPT(NG)=NINT(XL(IPIOF,6))                  !for montecarlo search
            if(IOPT(NG).lt.0) print_out=.true.
c--------------pg=0 : site with inversion centre
c--------------pg=1 : site with no inversion centre
            ipg(NG)=abs(NINT((XL(IPIOF,6)-IOPT(NG))*100))
            CHI(NG)=0.
            xmass(ng)=0.     !initializes total mass of the concerned rbg
            do kk=1,3
              xcm(kk,ng)=0.  !relative cartesian coord. of the centre of mass
            end do
c---------setting default value
            if (iopt(ng).eq.0) then
              iopt(ng)=1
              xl(ipiof,6)=1.0
            end if
C----------rigid-body-constraints-----------------------------------------
            if(abs(IOPT(NG)).EQ.1.or.abs(IOPT(NG)).EQ.5) then    !IOPT=1,5
c-------------------------------------------------------------------------
              call arrange(xl(ipiof,15),1)
              CHI(ng)=xl(ipiof,15)
c------------read TLS matrix if any: label 11,22,33,12,13,23 (+21,31,32 for S)
c------------units : T in angstroms**2, L in radians**2, S in radians*degrees
c------------TLS parameters are always referred to a main rbg !!!
C--------------------------------------------------------------------
              if(abs(iopt(ng)).eq.5) then        !IOPT=5
C--------------------------------------------------------------------
c1
c--------------initializes the TLS parameters of the rbg
                do ii=1,6
                  rbgt(ii,ng)=0.
                  rbgl(ii,ng)=0.
                  rbgs(ii,ng)=0.
                end do
                rbgs(7,ng)=0.   ! element S21   (S is a non symmetric matrix
                rbgs(8,ng)=0.   ! element S31    i.e. 9 parameters
                rbgs(9,ng)=0.   ! element S32    but with 8 unknowns to refine)
                itls(ng)=1      !rbg/tl option
                if((ntls+21).gt.mpar) then      !mpar is too low
                  write(*,'(a,i2,a,i2)')
     *'==> Dimension of MPAR = ',mpar,
     *' too low ! Dimension required : ',ntls+21
        call stop_cond('Dimension out of range with TLS option',1)
                end if
c--------------loop over all TLS elements of the current rbg
                do kk=1,6
                  rbgt(kk,ng)=par(iph,ntls+kk)  ! Tij in angstroms^2
                  rbgl(kk,ng)=par(iph,ntls+kk+6) ! Lij in radians^2
                end do
c--------------fixing relation between S11, S22 and S33 : S22=-S11-S33
             par(iph,ntls+12+2)=-par(iph,ntls+12+1)-par(iph,ntls+12+3)
                do kk=1,9
                  rbgs(kk,ng)=par(iph,ntls+12+kk) ! Sij in angstroms*radians
                end do
                ntls=ntls+21    !offset to apply to continue with next rbg/TLS
              end if
              goto 112
            end if
c----------rigid-body satellite
c-----------search of the first and 2d reference atoms to define the starting
c-----------axis to calculate theta and phi of the satellite-----------
            IF(abs(IOPT(NG)).EQ.2) THEN            !IOPT=2
C-----------------------------------------------------------------------
c------------absolute number of the reference group
              IGR(NG)=abs(NINT((XL(IPIOF,6)-IOPT(NG))*100))
c------------getting the 1st and the 2nd reference atom : P16
              ISAT(NG,1)=NINT(XL(IPIOF,16))
              ISAT(NG,2)=NINT((XL(IPIOF,16)-ISAT(NG,1))*100)
c------------are the reference atoms corrects ?
              JG=IGR_OFF
              DO J=1,N
                IF(NUM(J+IOF).EQ.1) JG=JG+1
                IF(JG.EQ.IGR(NG).AND.(J+IOF).EQ.ISAT(NG,1)) GOTO 109
              END DO
              write(*,'(a,i2,a)') ' => The satellite group No',NG,
     *              ' has not a reference group'
              write(*,'(a)')'   or the reference group is not correct'
              call stop_cond(' Satellite group without ref. group',1)
c------------getting usefull informations for satellite group
109           IF(NG.LE.JG)
     *call stop_cond('Put Main Group before its satellites',1)
c-----------getting coordinates of the central reference atom (1st one)
              DO J=1,3
                XL(IPIOF,J+11)=XL(ISAT(NG,1),J)
                COSAT1(NG,J)=XL(ISAT(NG,1),J)
              END DO
c-----------getting coordinates of the second reference atom
              IF(ISAT(NG,1).EQ.ISAT(NG,2)) THEN
                DO J=1,3
                  COSAT2(NG,J)=XL(ISAT(NG,1),J+11)
                END DO
               ELSE
c-------------general case: the 2 reference atoms are defined
                DO J=1,3
                  COSAT2(NG,J)=XL(ISAT(NG,2),J)
                END DO
              END IF
              IF(ISAT(NG,2).NE.0) THEN
c--------------we calculate theta and phi angle of the satellite group from
c--------------reference atoms 1 and 2.
c--------------origine is atom 1 and the direction 1->2 is the Z axis of the
c--------------satellite group
                DO K=1,3
                  XI(K)=COSAT1(NG,K)-COSAT2(NG,K)
                END DO
c--------------reduced coordinates to normal coordinates
                DO K=1,3
                  DX(K)=0.
                  DO L=1,3
                    DX(K)=DX(K)+XI(L)*FMAT(K,L,IPH)
                  END DO
                END DO
c
c--------------spherical coordinates are calculated
                call get_spheric_coord(dx,xdist,xtheta,xphi)
                XL(IPIOF,7)=XTHETA
                XL(IPIOF,8)=XPHI
               ELSE
c-------------the 2nd reference atom was not defined: theta and phi are those
c-------------of the main group
                XL(IPIOF,7)=XTH(IGR(NG))
                XL(IPIOF,8)=XPH(IGR(NG))
              END IF
cc------------General internal rotation is the same for main and satellite groups
c              CHI(NG)=CHI(IGR(NG))
              GOTO 112
            END IF
c----------Generating spherical coordinates from fractional coordinates
            IF(abs(IOPT(NG)).EQ.3) THEN    !IOPT=3
c-----------------------------------------------------------------------
c
c---Get THETA,PHI,CHI from the first atom coordinates,the centre of
c   the RBG and P9,P10,P11 that, on input defines the fractional
c   coordinates of an atom (eventually fictitious) that defines the XZ plane.
c   It is supposed that V3=(P1,P2,P3)-(P12,P13,P14) defines the "z" axis of
c   the molecular frame. The "y" axis is perpendicular to the plane defined
c   by V3 and V1=(P9,P10,P11)-(P12,P13,P14)
c   The calculation of CHI(NG) is done later
         do k=1,3
         qh(k)=0.0
          do L=1,3
           qh(k)=qh(k)+(XL(IPIOF,L)-XL(IPIOF,L+11))*FMAT(K,L,IPH)   !V3=z
          end do
         end do
c
c  xalpha,xphi defines the global rotations THETA and PHI
c  these values are stored in XL(ipiof,7) and XL(ipiof,8)
c
         call get_spheric_coord(qh,xdist,xalpha,xphi)
         XL(ipiof,7)=xalpha   !THETA
         XL(ipiof,8)=xphi     !PHI
c------------parameter option is set to +/-1 (rbg option) for next cycle
              xl(ipiof,6)=1.*sign(1.,xl(ipiof,6))
              goto 112
            END IF    !(IOPT(NG)).EQ.3)
c----------generating chain coordinates--------------------------------------
            IF(ABS(IOPT(NG)).EQ.4) THEN    !IOPT=4
c----------------------------------------------------------------------------
c------------if chain option requested: interatomic distance, angle and order of
c------------the generating axis
              DISTMOY=xl(ipiof,9)
              ALPHAMOY=xl(ipiof,10)
              NORDRE=NINT(xl(ipiof,11))
c------------default values
              IF(DISTMOY.EQ.0.0) DISTMOY=1.54/2.
              IF(ALPHAMOY.EQ.0.0) ALPHAMOY=114.*pi/180.
              IF(NORDRE.EQ.0) NORDRE=2
c------------origine of the atomic plane in the chain
c------------ex: 3 planes for ch3ch2ch3  along Z
c------------    1 plane for benzene lying in the xy plane
              ZOFFSET=100*(ABS(XL(IPIOF,6)-IOPT(NG)))-1.
              IF(ZOFFSET.LT.0.) ZOFFSET=0.      !default value is 1st plane
c------------parameter option is set to one for next cycle
              xl(ipiof,6)=1.*sign(1.,xl(ipiof,6))
c------------default value for internal rotation is zero
              call arrange(xl(ipiof,15),1)
              CHI(ng)=xl(ipiof,15)
              GOTO 112
            END IF
            write(*,'(a,I2,a)')' => Group No',NG,' unknown option'
            call STOP_cond(' abs(P6) must be equal to:
     *           1, 2, 3, 4 or 5',1)
c----------common area for any option : NUM(I+IOF)=1
112         CONTINUE
c----------orientation angles of the group: theta and phi
            DO J=7,8
              CALL ARRANGE(XL(IPIOF,J),1)
            END DO
            XTH(NG)=XL(IPIOF,7)
            XPH(NG)=XL(IPIOF,8)
c----------matrix of rotation for the group : Phi and theta
            XA(1,1,NG)=+COS(XTH(NG))*COS(XPH(NG))
            XA(2,1,NG)=+COS(XTH(NG))*SIN(XPH(NG))
            XA(3,1,NG)=-SIN(XTH(NG))
            XA(1,2,NG)=-             SIN(XPH(NG))
            XA(2,2,NG)=+             COS(XPH(NG))
            XA(3,2,NG)=0.
            XA(1,3,NG)=+SIN(XTH(NG))*COS(XPH(NG))
            XA(2,3,NG)=+SIN(XTH(NG))*SIN(XPH(NG))
            XA(3,3,NG)=+COS(XTH(NG))
c---------------------------------------------------------------------
         IF(IABS(IOPT(ng)).EQ.3) THEN   !IOPT=3
c---------------------------------------------------------------------
c
c  Calculation of the CHI(NG). The vector V2 = V3 x V1 defines the internal
c  "y" axis. So V2=(0,mod(V2),0) in internal coordinates. The rigid body
c  rotation is obtained from an initial state where the Normal and internal
c  frames coincide, by applying first the rotation CHI(NG) (Matrix XAp) and
c  then the THETA-PHI rotation (Matrix XA), so X = XA.XAp.x, or XAT.X = XAp.x
c  For X=V2, XAp.V2 = (mod(V2)*sin(Rz), mod(V2)*cos(Rz), 0). Rz can also
c  be calculated from the spherical coordinates of XAp.V2: Rz=-pi/2+xphi
c  qh=V3 comes from a previous calculation.
         do k=1,3
         xi(k)=0.0
          Do L=1,3
           xi(k)=xi(k)+(XL(IPIOF,L+8)-XL(IPIOF,L+11))*FMAT(K,L,IPH)   !V1
          end do
         end do
         xi(4)=xi(3)*qh(2)-xi(2)*qh(3)
         xi(5)=xi(1)*qh(3)-xi(3)*qh(1)    !Vector product V3xV1
         xi(6)=xi(2)*qh(1)-xi(1)*qh(2)
c----------Transform normal coordinates to internal cartesian coordinates
c          First multiply by the tranpose(inverse) of XA
            DO K=1,3
              dx(K)=0.
c              xi(K)=0.
              DO L=1,3
                dx(K)=dx(K)+xi(L+3)*XA(L,K,ng)  !!   y-axis (intermediate)
c                xi(K)=xi(K)+qh(L)*XA(L,K,ng)    !!   z-axis (intermediate)
              END DO
            END DO
c         write(*,'(a,3f10.4)')' => Vector yi :',(dx(k),k=1,3)
c         write(*,'(a,3f10.4)')' => Vector zi :',(xi(k),k=1,3)
         call get_spheric_coord(dx,xdist,xalpha,xphi)
         aux=dx(2)/xdist
         if(abs(aux).gt.1.0) aux=sign(1.0,aux)
         rr=acos(aux)
         if(abs(rr-xphi+pi/2.).gt.0.0001)
     +    write(*,'(a,3f10.4)')' => Warning! acos(V2(y)/V2):',rr
         XL(ipiof,15)=-pi/2+xphi      !PHI
         call arrange(xl(ipiof,15),1)
         CHI(NG)=XL(ipiof,15)
         ENDIF                                         !IOPT=3
c-----------------------------------------------------------
c   Set up of the CHI(NG)=XAP matrix
c
c----------matrix of rotation for the group : Rz
            XAp(1,1,NG)=+COS(CHI(NG))
            XAp(2,1,NG)=+SIN(CHI(NG))
            XAp(3,1,NG)= 0.0
            XAp(1,2,NG)=-SIN(CHI(NG))
            XAp(2,2,NG)=+COS(CHI(NG))
            XAp(3,2,NG)= 0.0
            XAp(1,3,NG)= 0.0
            XAp(2,3,NG)= 0.0
            XAp(3,3,NG)=+1.0
c----------coordinates of the centre of the rigid-body group in parameters
c----------P12 to P14 of the first atom
            DO J=12,14
              IF(abs(IOPT(NG)).EQ.2) THEN
c------------satellite group
                COG(J-11,NG)=COSAT1(NG,J-11)
               ELSE
c------------other
c               CALL ARRANGE(XL(IPIOF,J),0)
                COG(J-11,NG)=XL(IPIOF,J)
              END IF
            END DO
c----------prepare b&s file: cartesian coord. of the center of the group xog
            DO K=1,3
              xog(k,ng)=0.
              DO L=1,3
                xog(k,ng)=xog(k,ng)+COG(l,ng)*FMAT(K,L,IPH)
              END DO
            END DO
          END IF
C----------------------------END IF(NUM(I+IOF).eq.1)!!!!!!
c--------common reading or calculations for any non-zero num(i) following
c--------the requested option
          IF(REC(I+IOF).NE.TOBJ(NG)) THEN
           write(*,'(a,a,a)')
     *      ' =>PB : Atoms in a group must have the same label ',
     *            'i.e "',TOBJ(NG),'"'
        call STOP_cond('  Atoms in a group must have the same label',1)
          END IF
          if(abs(iopt(ng)).le.2.or.abs(iopt(ng)).eq.5) then
c----------reading of spherical coordinates for rigid-body default option and
c----------satellite option
c----------distance, alpha and Rz : internal coordinates of atoms
            DIST(I+IOF)=XL(I+IOF,9)
            DO J=10,11
              CALL ARRANGE(XL(I+IOF,J),1)
            END DO
            ALPHA(I+IOF)=XL(I+IOF,10)
            RZ(I+IOF)=XL(I+IOF,11)
            GOTO 116
          end if
c------------------------------------------------------------
          IF(abs(IOPT(NG)).EQ.3) then       !IOPT=3
c------------------------------------------------------------
c----------generating spherical coordinates for default option
c----------reduced coordinates from centre of the group
            XI(1)=XL(I+IOF,1)-XL(IPIOF,12)
            XI(2)=XL(I+IOF,2)-XL(IPIOF,13)
            XI(3)=XL(I+IOF,3)-XL(IPIOF,14)
c----------calculating the normal coordinates
            DO K=1,3
              DX(K)=0.
              DO L=1,3
                DX(K)=DX(K)+XI(L)*FMAT(K,L,IPH)
              END DO
            END DO
c----------Transform normal coordinates to internal cartesian coordinates
c----------First multiply by the tranpose(inverse) of XA
            DO K=1,3
              XI(K)=0.
              DO L=1,3
                XI(K)=XI(K)+DX(L)*XA(L,K,ng)  !Intermediate frame
              END DO
            END DO
            DO K=1,3
              Dx(K)=0.
              DO L=1,3
                Dx(K)=Dx(K)+XI(L)*XAP(L,K,NG)  !Now Dx can be used for getting
              END DO                           !Internal spherical coordinates
            END DO
c----------spherical coordinates
            call get_spheric_coord(dx,xdist,xalpha,xphi)
            call arrange(xalpha,1)
            call arrange(xphi,1)
            dist(i+iof)=xdist
            alpha(i+iof)=xalpha
            rz(i+iof)=xphi                    !get internal Phi
            goto 115
          end if  !Endif abs(IOPT(NG)).EQ.3
c------------------------------------------------------------
          IF(abs(IOPT(NG)).EQ.4) then    !IOPT=4
c------------------------------------------------------------
c----------generating the atomic chain
c----------normal coordinates
            ROT=(2.*PI/NORDRE)*(NUM(I+IOF)-1)+CHI(ng)
            dx(1)=DISTMOY*COS(ALPHAMOY/2.)*COS(ROT)
            dx(2)=DISTMOY*COS(ALPHAMOY/2.)*SIN(ROT)
            dx(3)=2.*(-ZOFFSET+(NUM(I+IOF)-1))*DISTMOY*SIN(ALPHAMOY/2.)
c----------spherical coordinates
            call get_spheric_coord(dx,xdist,xalpha,xphi)
            dist(i+iof)=xdist
            alpha(i+iof)=xalpha
            rz(i+iof)=xphi
          END IF
c--------we store the new calculated spherical coordinates
115       XL(I+IOF,9)=DIST(I+IOF)
          XL(I+IOF,10)=ALPHA(I+IOF)
          XL(I+IOF,11)=RZ(I+IOF)
c--------common area for any option: we generate the reduced coordinates
c--------from the spherical coordinates
c--------1 Coordinates in the intermediate frame (molecular+CHI rotation)
c-------- note that in case of satellite chi(ng)=0.
116       xx=DIST(I+IOF)*SIN(ALPHA(I+IOF))*COS(RZ(I+IOF)+CHI(NG))
          yy=DIST(I+IOF)*SIN(ALPHA(I+IOF))*SIN(RZ(I+IOF)+CHI(NG))
          zz=DIST(I+IOF)*COS(ALPHA(I+IOF))
c--------2 The group rotations (theta,phi, chi) are executed
          DX(1)=XA(1,1,NG)*XX+XA(1,2,NG)*YY+XA(1,3,NG)*ZZ
          DX(2)=XA(2,1,NG)*XX+XA(2,2,NG)*YY+XA(2,3,NG)*ZZ
          DX(3)=XA(3,1,NG)*XX+XA(3,2,NG)*YY+XA(3,3,NG)*ZZ
c--------3 save the normal coordinates for the derivatives calculations
          X0(I+IOF)=DX(1)
          Y0(I+IOF)=DX(2)
          Z0(I+IOF)=DX(3)
c--------4 calculating the reduced coordinates
          DO K=1,3
            XI(K)=0.
            DO L=1,3
              XI(K)=XI(K)+DX(L)*CMAT(K,L,IPH)
            END DO
c----------absolute reduced coordinates
            XI(K)=XI(K)+COG(K,NG)
c----------storage of the coordinates
            XL(I+IOF,K)=XI(K)
          END DO
c--------searching the centre of mass of the rbg for any option
c         if(abs(iopt(ng)).eq.5.or.
c    *(abs(iopt(ng)).eq.2.and.abs(iopt(igr(ng))).eq.5)) then  !IOPT=5
C----------------------------------------------------------------------
            jg=ng
            if(abs(iopt(ng)).eq.2) jg=igr(ng)
            if(ipg(jg).eq.1) then        !the whole molecule is described
              call get_atomic_mass(ntyp(i+iof),wght,iget)
              if(iget.ne.0) then
                write(*,'(3a)')' => Undefined atom : ',ntyp(i+iof),
     *                         ' in centre of mass calculations'
                call stop_cond(' Problem with IPG=1 option',1)
              end if
c------------mean position value for each orthogonal direction x, y and z
              xcm(1,jg)=(xmass(jg)*xcm(1,jg)+x0(i+iof)*wght)
     *                  /(xmass(jg)+wght)
              xcm(2,jg)=(xmass(jg)*xcm(2,jg)+y0(i+iof)*wght)
     *                  /(xmass(jg)+wght)
              xcm(3,jg)=(xmass(jg)*xcm(3,jg)+z0(i+iof)*wght)
     *                  /(xmass(jg)+wght)
              xmass(jg)=xmass(jg)+wght
            end if
c         end if
C------------------------------------------------------------------------
         ELSE           !free atoms  NUM(I+IOF)=0
C------------------------------------------------------------------------
c--------reduced coordinates to normal coordinates
          DO K=1,3
            DX(K)=0.
            DO L=1,3
              DX(K)=DX(K)+XL(I+IOF,L)*FMAT(K,L,IPH)
            END DO
          END DO
c--------storage of the normal coordinates for the b&s file
          X0(I+IOF)=DX(1)
          Y0(I+IOF)=DX(2)
          Z0(I+IOF)=DX(3)
C------------------------------------------------------------------------
        END IF                !End if(NUM(I+IOF).ne.0) ....
C------------------------------------------------------------------------
      END DO                  !END OF MAIN LOOP OVER ATOMS
C------------------------------------------------------------------------
c----ready for the next phase
      NGMAX(IPH)=NG
C------------------------------------------------------------------------------
C----writing informations in unit I_OUT and on the terminal if required: iopt(ng)<0
C------------------------------------------------------------------------------
c----write current information to screen
       if(print_out) then
       write(*,654)IPH
       WRITE(i_out,654) IPH
 654   FORMAT(1X,'==========> Phase ',I2)
       endif
      do jg=IGR_OFF+1,NG
      IF(abs(IOPT(jg)).EQ.3.and.ipg(jg).eq.1) then !IOPT=3
        write(i_out,'(/a,i2,a,f8.1,a)')
     +   ' => Mass of RBG no.: ',jg,' is ',xmass(jg),' atomic units'
            DO k=1,3
              XI(k)=0.
              DO l=1,3
                XI(k)=XI(k)+xcm(l,jg)*CMAT(k,l,IPH)
              END DO
c------------absolute reduced coordinates
              XI(k)=XI(k)+COG(k,jg)
            END DO
        write(i_out,'(a,3f9.4/)')
     +' => Fractional coordinates of the Center of Mass:',(xi(k),k=1,3)
      endif
      end do     !over ig
c-------------------------------------------------------------------------
c
      IG=IGR_OFF
c-----------------------------------------------------------------------
      DO I=1,N               !SECOND LOOP OVER ATOMS  before FNN calc
c-----------------------------------------------------------------------
C------free atoms
c-----------------------------------------------------------------------
        IF(NUM(I+IOF).EQ.0) THEN         !IF-BLOCK FOR FREE ATOMS
c-----------------------------------------------------------------------
          if(xl(i+iof,6).lt.0.0) then
           write(*,128)ATEXT(I+IOF),(XL(I+IOF,J),J=1,4)
           WRITE(i_out,128) ATEXT(I+IOF),(XL(I+IOF,J),J=1,4)
          endif
128       FORMAT(1X,A4,3F6.3,2x,'Biso:',F6.3)
          BSUM=0.
          DO JJ=9,14
            BSUM=BSUM+abs(XL(I+IOF,JJ))
          END DO
          IF(BSUM.NE.0.) THEN
c----------Atomic temperature factors Bij/Uij transformed in Betaij
            if(nint(xl(I+IOF,15)).ne.0) then
              if(nint(xl(I+IOF,15)).eq.1) then
                dum_lab='Uij'
                idum=1
                xdum=1.
               else
                write(*,'(a)')
     *           'Error in converting atomic temperature factors'
                 call stop_cond('Parameter xl(iat,15) is 1 (Uij)',1)
              end if
              do ki=1,3
                bij(ki,ki)=xl(I+IOF,8+ki)
              end do
              bij(1,2)=xl(I+IOF,12)
              bij(1,3)=xl(I+IOF,13)
              bij(2,3)=xl(I+IOF,14)
              bij(2,1)=bij(1,2)
              bij(3,1)=bij(1,3)
              bij(3,2)=bij(2,3)
              do ki=1,3
                do kj=1,3
                  oti(ki,kj)=cmat(ki,kj,iph)
                  toti(ki,kj)=ctmat(ki,kj,iph)
                end do
              end do
c              call matrix(bij,oti,qq,auxx,'MATMUL')
c              call matrix(toti,qq,beta,auxx,'MATMUL')
               call matmult(bij,oti,qq,3)
               call matmult(toti,qq,beta,3)
c------------stores calculated Betaij
              do ki=1,3
                xl(I+IOF,8+ki)=beta(ki,ki)*(2.*pi*pi)*xdum
              end do
              xl(I+IOF,12)=beta(1,2)*(2.*pi*pi)*xdum
              xl(I+IOF,13)=beta(1,3)*(2.*pi*pi)*xdum
              xl(I+IOF,14)=beta(2,3)*(2.*pi*pi)*xdum
            end if
            if(xl(i+iof,6).lt.0.0) then
            WRITE(i_out,'(3a)')
     *'==> Converting ',dum_lab,' factors into Betaij factors'
            WRITE(i_out,1281) (XL(I+IOF,J),J=9,14)
1281        FORMAT(1X,'Betaij: ',6F10.5)
              if(nint(xl(I+IOF,15)).ne.0) write(*,'(3a)')
     *'==> Converting ',dum_lab,' factors into Betaij factors'
              write(*,1281)(XL(I+IOF,J),J=9,14)
            end if
            xl(I+IOF,15)=0.
          END IF
c--------ball&sticks
      if(.not.ort_bs_m)
     *    WRITE(29+iph,650) NTYP(I+IOF),
     *                  X0(I+IOF),Y0(I+IOF),Z0(I+IOF)
650       FORMAT(A4,5X,3(F10.5,2X))
          GOTO 652
c-----------------------------------------------------------------------
        END IF                 !END IF-BLOCK FOR FREE ATOMS
c-----------------------------------------------------------------------
        IF(NUM(I+IOF).EQ.1) THEN     !IF-BLOCK FOR RBG'S
c-----------------------------------------------------------------------
          IG=IG+1
C--------rigid body option
          IF(abs(IOPT(IG)).EQ.1.or.abs(iopt(ig)).eq.3.or.
     *       abs(iopt(ig)).eq.5) THEN
            if(iopt(ig).lt.0) then
             write(*,124) REC(I+IOF),IG
             WRITE(i_out,124) REC(I+IOF),IG
            endif
124         FORMAT(/,1X,'==> Standard option : rigid-body group '
     *             ,A2,' Nr ',I2)
            IF(abs(iopt(ig)).EQ.3) THEN
              if(iopt(ig).lt.0) then
               write(*,126)
               WRITE(i_out,126)
              endif
126           FORMAT(1x,'==> Generating spherical coordinates')
            END IF
            GOTO 122
          END IF
C--------OPTION CHAINE
          IF(ABS(IOPT(IG)).EQ.4) THEN
            if(iopt(ig).lt.0) then
             WRITE(*,127) rec(i+iof),ig
             WRITE(i_out,127) rec(i+iof),ig
            endif
127         FORMAT(/,1x,'==> Generating chain coordinates for group ',
     *       a2,' Nr ',i2)
            GOTO 122
          END IF
c--------satellite group option: the only left possible solution
          if(iopt(ig).lt.0) then
          WRITE(*,123) REC(I+IOF),IG,
     *     ATEXT(ISAT(IG,1)),ATEXT(ISAT(IG,2)),IGR(IG)
          WRITE(i_out,123) REC(I+IOF),IG,ATEXT(ISAT(IG,1)),
     *                 ATEXT(ISAT(IG,2)),IGR(IG)
          endif
123       FORMAT(1X,'==> Satellite group ',A2,' Nr ',I2,2X,
     *           '-> reference atoms : (',A4,',',A4,
     *           ') of group Nr ',I2)
C--------informations about any group
122       if(iopt(ig).lt.0) then
            WRITE(*,300) tobj(ig),(COG(J,IG),J=1,3),XTH(IG),
     *       XPH(IG),CHI(IG)
          WRITE(i_out,300) tobj(ig),(COG(J,IG),J=1,3),XTH(IG),
     *       XPH(IG),CHI(IG)
          endif
300       FORMAT(1x,a2,' :',3F6.3,
     *           4X,'Theta :',F6.3,2X,'Phi :',F6.3,2X,'Chi :',F6.3)
c---T in angstroms^2 and L in degrees^2 and S in angstroms*degrees
          if(abs(iopt(ig)).eq.5) then
c----------calculating the reduced coordinates of the centre of mass
            DO kk=1,3
              XI(kk)=0.
              DO ll=1,3
                XI(kk)=XI(kk)+xcm(ll,ig)*CMAT(kk,ll,IPH)
              END DO
c------------absolute reduced coordinates
              XI(kk)=XI(kk)+COG(kk,ig)
            END DO
            xpi=180./pi
            xpi2=xpi*xpi
c----------writes the centre of mass of the rbg
       if(iopt(ig).lt.0) then
            WRITE(i_out,'(2a,3f6.3)') ' ==> TLS option: coord. ',
     *          'of centre of mass:',(xi(k),k=1,3)
            WRITE(i_out,223) rbgt(1,ig), rbgt(4,ig), rbgt(5,ig),
     *rbgl(1,ig)*xpi2, rbgl(4,ig)*xpi2, rbgl(5,ig)*xpi2,
     *rbgs(1,ig)*xpi, rbgs(4,ig)*xpi, rbgs(5,ig)*xpi,
     *rbgt(2,ig), rbgt(6,ig),
     *rbgl(2,ig)*xpi2, rbgl(6,ig)*xpi2,
     *rbgs(7,ig)*xpi, rbgs(2,ig)*xpi, rbgs(6,ig)*xpi,
     *rbgt(3,ig),
     *rbgl(3,ig)*xpi2,
     *rbgs(8,ig)*xpi, rbgs(9,ig)*xpi, rbgs(3,ig)*xpi
              write(*,'(2a,3f7.3)') ' ==> TLS option: coord.',
     *            ' of centre of mass:',(xi(k),k=1,3)
              write(*,223) rbgt(1,ig), rbgt(4,ig), rbgt(5,ig),
     *rbgl(1,ig)*xpi2, rbgl(4,ig)*xpi2, rbgl(5,ig)*xpi2,
     *rbgs(1,ig)*xpi, rbgs(4,ig)*xpi, rbgs(5,ig)*xpi,
     *rbgt(2,ig), rbgt(6,ig),
     *rbgl(2,ig)*xpi2, rbgl(6,ig)*xpi2,
     *rbgs(7,ig)*xpi, rbgs(2,ig)*xpi, rbgs(6,ig)*xpi,
     *rbgt(3,ig),
     *rbgl(3,ig)*xpi2,
     *rbgs(8,ig)*xpi, rbgs(9,ig)*xpi, rbgs(3,ig)*xpi
223           format(1x,3x,'|',3(f6.4,1x),'|',1x,3x,'|',
     *3(F6.2,1x),'|',1x,3x,'|',3(f6.4,1x),'|',/,
     *1x,'T= |',7x,2(f6.4,1x),'|',1x,'L= |',7x,2(F6.2,1x),'|',1x,'S= |',
     *3(f6.4,1x),'|',/,
     *1x,3x,'|',14x,(f6.4,1x),'|',1x,3x,'|',14x,(F6.2,1x),'|',1x,3x,'|',
     *3(f6.4,1x),'|')
       CALL DIAG_TL(tobj(ig),rbgt,rbgl,ig,i_out,i_sum,ICYCLE_C,MCYCLE)
            end if
          end if
          if(abs(iopt(ig)).eq.1.or.abs(iopt(ig)).eq.3.or.
     *       abs(iopt(ig)).eq.5) then
            if(iopt(ig).lt.0) then
             WRITE(i_out,113)
             write(*,113)
            endif
113         format(1x,'Nr',3x,'X',5x,'Y',5x,'Z',5x,'Biso',6x,
     *             'D',5x,'Alpha',5x,'Rz')
          end if
        END IF
c------information for each atom if required
c------option 1
        IF(abs(IOPT(IG)).EQ.1.OR.abs(IOPT(IG)).EQ.3.or.
     *     abs(iopt(ig)).eq.5) THEN
          if(iopt(ig).lt.0) then
            WRITE(*,117) NUM(I+IOF),
     *      (XL(I+IOF,J),J=1,4),DIST(I+IOF),ALPHA(I+IOF),RZ(I+IOF)
          WRITE(i_out,117) NUM(I+IOF),(XL(I+IOF,J),J=1,4),
     *                 DIST(I+IOF),ALPHA(I+IOF),RZ(I+IOF)
          endif
117       FORMAT(1X,I2,3F6.3,4F8.3)
          GOTO 125
        END IF
c------chain option
        IF(ABS(IOPT(IG)).EQ.4) THEN
          IF(NUM(I+IOF).EQ.1) THEN
            if(iopt(ig).lt.0) then
             WRITE(*,118) NUM(I+IOF),(XL(I+IOF,K),K=1,4),RZ(I+IOF)
             WRITE(i_out,118) NUM(I+IOF),(XL(I+IOF,K),K=1,4),RZ(I+IOF)
            endif
118         FORMAT(1X,I2,3F6.3,4F8.3,41X,'RZ:',F6.3)
            GOTO 125
          END IF
c--------calculating interatomic distances and angles
          II=I+IOF
          III=II-1
c--------1 distance
          A2=0.
          DO K=1,3
            DX(K)=XL(III,K)-XL(II,K)
           do kk=1,3
             auxx(k,kk)=FMAT(k,kk,IPH)
           end do
          END DO
c          CALL MATRIX(FMAT,DX,D12,O,'LENGTH')
           call veclength(Auxx,DX,d12)
          IF(D12.le.0.000001) THEN
            if(iopt(ig).lt.0) then
             WRITE(*,119) ATEXT(III),ATEXT(II)
             WRITE(i_out,119) ATEXT(III),ATEXT(II)
            endif
          END IF
119       FORMAT(1X,'**** The distance (',A4,')-(',A4,') is zero ****')
C--------2 angle
          IF(REC(I+1+IOF).EQ.TOBJ(IG).AND.
     *     NUM(I+1+IOF).EQ.(NUM(I+IOF)+1)) THEN
            DO K=1,3
              DX(K)=XL(II-1,K)-XL(II+1,K)
            END DO
c            CALL MATRIX(FMAT,DX,D13,O,'LENGTH')
           call veclength(Auxx,DX,d13)
            IF(D13.lt.0.000001) THEN
              if(iopt(ig).lt.0) then
               WRITE(*,119) ATEXT(II-1),ATEXT(II+1)
               WRITE(i_out,119) ATEXT(II-1),ATEXT(II+1)
              endif
            END IF
            DO K=1,3
              DX(K)=XL(II,K)-XL(II+1,K)
            END DO
c            CALL MATRIX(FMAT,DX,D23,O,'LENGTH')
           call veclength(Auxx,DX,d23)
            IF(D23.lt.0.000001) THEN
              if(iopt(ig).lt.0) then
               WRITE(*,119) ATEXT(II),ATEXT(II+1)
               WRITE(i_out,119) ATEXT(II),ATEXT(II+1)
              endif
            END IF
            IF(D12.lt.0.000001.OR.D23.lt.0.000001) THEN
              A2=0.
             ELSE
              A2=(D12*D12+D23*D23-D13*D13)/(2.0*D12*D23)
              IF(A2.GT.1.0) A2=1.
              IF(A2.LT.-1.0) A2=-1.
              A2=ACOSD(A2)
            END IF
          END IF
          IF(A2.EQ.0.0) THEN
            if(iopt(ig).lt.0) then
             WRITE(*,120) NUM(I+IOF),(XL(II,K),K=1,4),
     *               NUM(I-1+IOF),NUM(I+IOF),D12,RZ(I+IOF)
             WRITE(i_out,120) NUM(I+IOF),(XL(II,K),K=1,4),
     *                   NUM(I-1+IOF),NUM(I+IOF),D12,RZ(I+IOF)
            endif
120         FORMAT(1X,I2,3F6.3,F8.3,2X,'D(',I2,'-',I2,') :',F6.3,
     *             23X,'RZ:',F6.3)
           ELSE
            if(iopt(ig).lt.0) then
            WRITE(*,121)NUM(I+IOF),(XL(II,K),K=1,4),
     *               NUM(I-1+IOF),NUM(I+IOF),D12,
     *               NUM(I-1+IOF),NUM(I+IOF),NUM(I+1+IOF),
     *               A2,RZ(I+IOF)
            WRITE(i_out,121)NUM(I+IOF),(XL(II,K),K=1,4),
     *                  NUM(I-1+IOF),NUM(I+IOF),D12,
     *                  NUM(I-1+IOF),NUM(I+IOF),NUM(I+1+IOF),
     *                  A2,RZ(I+IOF)
             endif
121         FORMAT(1X,I2,3F6.3,F8.3,2X,'D(',I2,'-',I2,') :',F6.3,2X,
     *             '(',I2,'-',I2,'-',I2,') :',F8.3,1X,'RZ:',F6.3)
          END IF
          GOTO 125
        END IF
c------satellite option
        IF(abs(IOPT(IG)).EQ.2) THEN
c--------calculate interatomic distance and angles of ref. atom 2 and 1
c--------then of satellite atom
          II1=ISAT(IG,2)
          II2=ISAT(IG,1)
          II3=I+IOF
c--------calculation of dist D23 and verification of dist(i)
          A2=0.
          DO K=1,3
            DX(K)=COSAT1(IG,K)-XL(II3,K)
           do kk=1,3
             auxx(k,kk)=FMAT(k,kk,IPH)
           end do
          END DO
c          CALL MATRIX(FMAT,DX,D23,O,'LENGTH')
           call veclength(Auxx,DX,d23)
          IF(D23.lt.0.000001) THEN
            if(iopt(ig).lt.0) then
             WRITE(*,119) ATEXT(II3),ATEXT(II2)
             WRITE(i_out,119) ATEXT(II3),ATEXT(II2)
            endif
          END IF
          IF(II1.EQ.0) THEN
c---------- ref atom 2 is not defined
            if(iopt(ig).lt.0)then
            WRITE(*,120) NUM(I+IOF),
     *        (XL(II3,K),K=1,4),NUM(I+IOF),NUM(II2),D23,RZ(I+IOF)
            WRITE(i_out,120) NUM(I+IOF),(XL(II3,K),K=1,4),
     *                   NUM(I+IOF),NUM(II2),D23,RZ(I+IOF)
            endif
            GOTO 125
          END IF
c--------2nd ref. atom is defined
c--------distance atome ref1-ref2 = d12
          DO K=1,3
            DX(K)=COSAT2(IG,K)-COSAT1(IG,K)
          END DO
c          CALL MATRIX(FMAT,DX,D12,O,'LENGTH')
           call veclength(Auxx,DX,d12)
          IF(D12.lt.0.000001) THEN
            if(iopt(ig).lt.0) write(*,'(a)')
     *        ' *** PB of distance in the main chain ***'
            if(iopt(ig).lt.0) then
             WRITE(*,119) ATEXT(II1),ATEXT(II2)
             WRITE(i_out,119) ATEXT(II1),ATEXT(II2)
            endif
          END IF
c--------distance from atom ref2-sat=d13
          DO K=1,3
            DX(K)=COSAT2(IG,K)-XL(II3,K)
          END DO
c          CALL MATRIX(FMAT,DX,D13,O,'LENGTH')
           call veclength(Auxx,DX,d13)
          IF(D13.lt.0.000001) THEN
            if(iopt(ig).lt.0) then
             WRITE(*,119) ATEXT(II3),ATEXT(II1)
             WRITE(i_out,119) ATEXT(II3),ATEXT(II1)
            endif
          END IF
          IF(D12.EQ.0.0.OR.D23.EQ.0.0) THEN
            A2=0.
           ELSE
            A2=(D12*D12+D23*D23-D13*D13)/(2.0*D12*D23)
            IF(A2.GT.1.0) A2=1.
            IF(A2.LT.-1.0) A2=-1.
            A2=ACOSD(A2)
          END IF
          IF(A2.EQ.0.0) THEN
            if(iopt(ig).lt.0) then
            WRITE(*,120) NUM(I+IOF),
     *       (XL(I+IOF,K),K=1,4),NUM(II3),NUM(II2),D23,RZ(I+IOF)
            WRITE(i_out,120) NUM(I+IOF),(XL(I+IOF,K),K=1,4),
     *               NUM(II3),NUM(II2),D23,RZ(I+IOF)
            endif
           ELSE
            if(iopt(ig).lt.0) then
            WRITE(*,121) NUM(I+IOF),
     *        (XL(I+IOF,K),K=1,4),NUM(II3),NUM(II2),D23,
     *        NUM(II3),NUM(II2),NUM(II1),A2,RZ(I+IOF)
            WRITE(i_out,121) NUM(I+IOF),(XL(I+IOF,K),K=1,4),
     *        NUM(II3),NUM(II2),D23,NUM(II3),NUM(II2),NUM(II1),
     *        A2,RZ(I+IOF)
            endif
          END IF
C-----------------------------------------------------------------------
        END IF                      !END IF-BLOCK FOR RBG'S
C-----------------------------------------------------------------------
c------b&s file for each option except free atoms: only atoms in asymmetric unit
125     dx(1)=X0(I+IOF)+xog(1,ig)
        dx(2)=Y0(I+IOF)+xog(2,ig)
        dx(3)=Z0(I+IOF)+xog(3,ig)
      if(.not.ort_bs_m)
     *  WRITE(29+iph,650) NTYP(I+IOF),(dx(kk),kk=1,3)
c------molview file : only atoms in asymmetric unit
652   if(.not.ort_bs_m)
     *  WRITE(19+iph,649) I+IOF,NTYP(I+IOF),(XL(I+IOF,K),K=1,3)
649     FORMAT('atom',3X,I2,1X,A4,2X,3(F8.5,1X))
C-----------------------------------------------------------------------
      END DO
C-----------------------------------------------------------------------
      if(.not.ort_bs_m) then
c----close molview and b&s files: the setting is now multiphase
c----molview: symmetry codes
      write(19+iph,'(/)')
      multg=mltg(iph)
      icase=1
      read(symb(iph,1),'(a1)') dum
c----finds the type of space group translation: P,R,F,I,A,B,C
      do k=1,4
        do kk=1,3
          tspg(k,kk)=0.
        end do
      end do
      if(dum.eq.'P'.or.dum.eq.'p') then
        ncryst_group=1
        goto 658
      end if
      if(dum.eq.'R'.or.dum.eq.'r') then
        ncryst_group=1
        goto 658
      end if
      if(dum.eq.'A'.or.dum.eq.'a') then
        ncryst_group=2
        tspg(2,2)=0.5
        tspg(2,3)=0.5
        goto 658
      end if
      if(dum.eq.'B'.or.dum.eq.'b') then
        ncryst_group=2
        tspg(2,1)=0.5
        tspg(2,3)=0.5
        goto 658
      end if
      if(dum.eq.'C'.or.dum.eq.'c') then
        ncryst_group=2
        tspg(2,1)=0.5
        tspg(2,2)=0.5
        goto 658
      end if
      if(dum.eq.'I'.or.dum.eq.'i') then
        ncryst_group=2
        tspg(2,1)=0.5
        tspg(2,2)=0.5
        tspg(2,3)=0.5
        goto 658
      end if
      if(dum.eq.'F'.or.dum.eq.'f') then
        ncryst_group=4
        tspg(2,2)=0.5
        tspg(2,3)=0.5
        tspg(3,1)=0.5
        tspg(3,3)=0.5
        tspg(4,1)=0.5
        tspg(4,2)=0.5
      end if
c----end of space group translation
658   do icryst_group=1,ncryst_group
        do ir=1,multg
          II=IABS(IVEC(IPH,IR))
          ISS=IVEC(IPH,IR)/II
          do J=1,3
            T(J)=icase*TR(IPH,IR,J)+tspg(icryst_group,j)
            do L=1,3
              IM(J,L)=icase*ISS*MOD6(II,J,L)
            end do
          end do
          write(19+iph,656) ((IM(j,l),l=1,3),t(j),j=1,3)
656       format('sym',5x,3(3i4,f12.6))
        end do
      end do
c----centrosymmetric space group
      if(icase.eq.1.and.icet(iph).eq.2) then
        icase=-1
        goto 658
      end if
      write(19+iph,657)
657   format(/,'=duplicate 0 0 1',/,'=link',/,'=that s all folks')
      WRITE(29+iph,655)
655   FORMAT('END')
c----close ouput files molview and b&s
      close(unit=19+iph)
      close(unit=29+iph)
      endif !ort_bs_m will be set to .true. after writing  *.ort file
c-----------------------------------------------------------------------------
c----end of preliminary calculations for each refinement loop-----------------
c-----------------------------------------------------------------------------
      return
      end
